#include "stdio.h"
#include "dos.h"
#include "conio.h"
#include "fcntl.h"

int  LoadPalette(char *PalFile);

typedef struct _SPR_HDR_ {

char NK[2];      // Signature of Sprite Editor: 'NK';
char Version;
char VideoMode;
char Type;
int  SizeX;
int  SizeY;
int  DataLen;    // Lengh of base Data: mustn't be equal to zero;
int  MaskLen;    // Length of Mask: If zero -> no mask in sprite;

} SPR_HDR;

SPR_HDR s,s2;

char Pal[256]={0};
char mem1[30000];
char mem2[30000];

void putpixel(int x,int y,char col)
{
_AH=0x0c;
_BH=0;
_CX=x;
_DX=y;
_AL=col;
asm int 10h;
}


void main(int argc,char **argv)
{
int h,h2,c,x,y;
unsigned i;
char mode;
int bytes;
char color;

if(argc<4) { puts("SPRCONV SPR1.SPR SPR2.SPR SPRCONV.TBL"); return; }

if((h=_open(argv[1],O_RDWR))==-1)
{
printf("Unable to open '%s'",argv[1]);
return;
}

if((h2=_open(argv[2],O_RDWR))==-1)
{
printf("Unable to open '%s'",argv[2]);
return;
}

if((c=_open(argv[3],O_RDWR))==-1)
{
cr:
if((c=_creat(argv[3],FA_ARCH))==-1)
{
printf("Unable to creat '%s'",argv[3]);
return;
}
}
else
{
if(_read(c,Pal,256)==-1)
{
puts("PAL Read error!");
return;
}
lseek(c,0,SEEK_SET);
close(c);
goto cr;
}

if(_read(h,&s,sizeof(s))==-1)
{
printf("Unable to read '%s' header",argv[1]);
close(h);
return;
}

if((s.Type!=80) && (s.Type!=3))
{
printf("Bad type number: '%d'; (must be 80)",s.Type);
close(h);
return;
}

if(_read(h2,&s2,sizeof(s2))==-1)
{
printf("Unable to read '%s' header",argv[2]);
close(h2);
return;
}

if((s2.Type!=80) && (s2.Type!=3))
{
printf("2: Bad type number: '%d'; (must be 80)",s2.Type);
close(h2);
return;
}

if(s2.SizeX!=s.SizeX || s2.SizeY!=s.SizeY)
{
printf("Different sizes: %d:%d and %d:%d;\n",s.SizeX,s.SizeY,s2.SizeX,s2.SizeY);
return;
}

i=s.SizeX*s.SizeY;

printf("Reading %ubytes to %p...\n",i,mem1);
_read(h,mem1,i);
printf("Reading %ubytes to %p...\n",i,mem2);
_read(h2,mem2,i);

puts("Ok!");

for(i=0; i<s2.SizeX*s2.SizeY; i++)
{
if((i%s.SizeX)>43 && (i%s.SizeX)<67)
{
if(mem1[i]!=mem2[i] && (mem2[i]==6 || mem2[i]==12)) continue;
}
if(mem1[i]!=mem2[i] && mem2[i]!=6) Pal[mem1[i]]=mem2[i];
}

s.SizeX=0;
for(i=0;i<256; i++)
{
if(Pal[i]!=i) s.SizeX++;

}

lseek(c,0,SEEK_SET);
_write(c,Pal,256);

  puts("Conversion completed:");
printf("DataLen: %d;\n",s.DataLen);
printf("SizeX  : %d;\n",s.SizeX);
printf("SizeY  : %d;\n",s.SizeY);

printf("Converted - %d;\n",s.SizeX);

close(c);
close(h2);
close(h);
}


