#include "stdio.h"
#include "dos.h"
#include "conio.h"
#include "fcntl.h"

int  LoadPalette(char *PalFile);

typedef struct _SPR_HDR_ {

char NK[2];      // Signature of Sprite Editor: 'NK';
char Version;
char VideoMode;
char Type;
int  SizeX;
int  SizeY;
int  DataLen;    // Lengh of base Data: mustn't be equal to zero;
int  MaskLen;    // Length of Mask: If zero -> no mask in sprite;

} SPR_HDR;

SPR_HDR s;

unsigned char buf[640]={ 0 };

void putpixel(int x,int y,char col)
{

_AH=0x0c;
_BH=0;
_CX=x;
_DX=y;
_AL=col;
asm int 10h;

}

void main(int argc,char **argv)
{
int h,x,y;
char mode;
int bytes;
char color;

if(argc<2) { puts("Extra argument missing"); return; }

if((h=_open(argv[1],O_RDWR))==-1)
{

printf("Unable to open '%s'",argv[1]);
return;

}

if(_read(h,&s,sizeof(s))==-1)
{

printf("Unable to read '%s' header",argv[1]);
close(h);
return;

}

if((s.Type!=80) && (s.Type!=3))
{

printf("Bad type number: '%d'; (must be 80)",s.Type);
close(h);
return;

}

mode=s.VideoMode;

asm {

xor ax,ax;
mov al,mode
int 10h

};

if(argc==3) LoadPalette(argv[2]);

for(y=0; y<s.SizeY; y++)
{

 bytes=_read(h,buf,s.SizeX);
 if(bytes==-1) {  puts("Read file error!");  }
 if(bytes==0)  {  puts("EOF reached!");  goto stop; }

for(x=0; x<s.SizeX; x++)
{

if((s.Type==3) && (buf[x]==255)) continue;

putpixel(x,y,buf[x]);

}

}

stop:

getch();

asm {
mov ax,0003h;
int 10h;
};

printf("DataLen: %d;\n\r",s.DataLen);
printf("SizeX  : %d;\n\r",s.SizeX);
printf("SizeY  : %d;\n\r",s.SizeY);

close(h);
}


int  LoadPalette(char *PalFile)
{
char Palette[1000];
int k=0;
int handle;
int sg=FP_SEG(Palette);
int so=FP_OFF(Palette);

if((handle=_open(PalFile, O_RDWR))==-1)  { printf("Unable to open palette from: %s!",PalFile); return -1; }
if((k=_read(handle,Palette,768))==-1)    { printf("Unable to read palette from: %s!",PalFile); return -1; }

close(handle);

asm {

mov ax,1012h
mov dx,sg
mov es,dx
mov dx,so

xor bx,bx
mov cx,256
int 10h

};

return 0;
}