/***************************************************************
                   B o b
                          W A Y r
                                   G r a p h i x

                      B W G . H        17.02.1992
 v1.0                Bob_WAYr_Graphix                   16.02.92
****************************************************************/

#if __STDC__
#define _Cdecl
#else
#define _Cdecl	cdecl
#endif

/****************************************************************/

#define    INT__        int           far   _Cdecl
#define    VOID_        void          far   _Cdecl
#define    LONG_        unsigned long far   _Cdecl
#define    CHAR_        char          far * _Cdecl
#define    UNS__        unsigned int  far   _Cdecl

/****************************************************************/

typedef struct {
                unsigned   x      : 5;
                unsigned   y      : 5;
                unsigned   size   : 3;
                unsigned   orient : 3;
               } Vfont;

enum graph_modes {   /* graphics modes for each driver  */
    EGATEXT    = 0,  /* CRT mode                        */
    VGA480     = 1,  /* 640x480 16 color 1 page         */
    EGA350     = 2,  /* 640x350 16 color 2 pages	*/
    EGA200     = 3   /* 640x200 16 color 4 pages	*/
};

enum  Pal_Colors{
    BWG_BLACK             =  0,     /* dark colors */
    BWG_BLUE              =  1,
    BWG_GREEN             =  2,
    BWG_CYAN              =  3,
    BWG_RED                  =  4,
    BWG_MAGENTA           =  5,
    BWG_BROWN             =  20,
    BWG_LIGHTGRAY         =  7,
    BWG_DARKGRAY          =  56,     /* light colors */
    BWG_LIGHTBLUE         =  57,
    BWG_LIGHTGREEN  =  58,
    BWG_LIGHTCYAN         =  59,
    BWG_LIGHTRED          =  60,
    BWG_LIGHTMAGENTA=  61,
    BWG_YELLOW            =  62,
    BWG_WHITE             =  63
};

enum BWG_Colors {
    Black,                  /* dark colors */
    Blue,
    Green,
    Cyan,
    Red,
    Magenta,
    Brown,
    LightGray,
    DarkGray,               /* light colors */
    LightBlue,
    LightGreen,
    LightCyan,
    LightRed,
    LightMagenta,
    Yellow,
    White
};


enum PORT_MOUSE {
    COM1       = 0,
    COM2       = 1
};

enum KEY_MOUSE {
    _INS        = 0x0001,
    _DEL        = 0x0002,
    Gplus      = 0x0004,
    Num5       = 0x0008,
    Gminus     = 0x0010,
    PrtScr     = 0x0020,
    Scroll     = 0x0040,
    NUM        = 0x0080,
    Num1       = 0x0100,
    Num2       = 0x0200,
    Num3       = 0x0400,
    Num4       = 0x0800,
    Num6       = 0x1000,
    Num7       = 0x2000,
    Num8       = 0x4000,
    Num9       = 0x4001
};
enum LOGIC_PUT {
    MOVput     = 0,
    ANDput     = 1,
     ORput     = 2,
    XORput     = 3
};



/****************************************************************/
#ifdef __cplusplus
extern "C" {
#endif

INT__   init            ( int mode );
VOID_   setgrmode       ( void );
VOID_   finit           ( void );
INT__   adaptertype     ( void );

VOID_   erasescr        ( int color );
VOID_   colmap          ( int index, int red, int green, int blue );
VOID_   defcolmap       ( void );
VOID_	regcol		( int index,int rgbRGB );
VOID_	overregcol	( int rgbRGB );

VOID_   logic           ( int ltype );
INT__   getscrlogic     ( void );
VOID_   color           ( int icol );
INT__   getscrcolor     ( void );
INT__   Xar             ( int xcoor );
INT__   Yar             ( int ycoor );
VOID_   windowoff       ( void );
VOID_   windowXY        ( int xoffset, int yoffset, int dx, int dy );

VOID_   moveab          ( int ix, int iy );
INT__   getXpos         ( void );
INT__   getYpos         ( void );

VOID_   linestyle       ( int pattern );
VOID_   linefirst       ( int first );
VOID_   linepattern     ( int pattern );
VOID_   lineXY          ( int x1, int y1, int x2, int y2 );
VOID_   lineabs         ( int x1, int y1, int x2, int y2 );
VOID_   linepos         ( int x, int y );
VOID_   lineab          ( int ix, int iy );
VOID_   lineh           ( int xdis );
VOID_   linew           ( int ydis );
VOID_   linef           ( int xdis );
VOID_	linefw		( int ydis );
VOID_   box             ( int dx, int dy );
VOID_   boxfill         ( int dx, int dy );
VOID_   barfill         ( int dx, int dy );
VOID_   fillstyle       ( int far* pattern );
VOID_   fillbgcolor     ( int color );

VOID_	boxcc		( int dx, int dy, int col1, int col2 );
VOID_	boxccc		( int x, int y, int dx, int dy, int mask, int color );

VOID_   setpattern      ( int p );
VOID_   rectab          ( int ix1, int iy1, int ix2, int iy2 );
VOID_   recfill         ( int ix1, int iy1, int ix2, int iy2 );

VOID_	charout		( char chr );
VOID_   textout         ( char far *str );
VOID_   text8           ( int x, int y, int col, int bcol, int patlog, char far *str );
VOID_   patlog          ( int bg_color, int mode );
VOID_   setchar         ( void far *pfar, int rows, int fontoffset );
CHAR_   findfont        ( int vdots, int setreset );
INT__	getvfont	( void );
VOID_	font14r		( void );
VOID_	font8r		( void );

LONG_   memblock	( int dx, int dy );
VOID_   rdblock		( int x, int y, int width, int height, void far *pfar );
VOID_   wrblock		( int x, int y, int width, int height, void far *pfar );

LONG_   memimage        ( int dx, int dy );
VOID_   rdimage         ( int x, int y, int width, int height, void far *pfar );
VOID_   wrimage         ( int x, int y, int width, int height, void far *pfar );
VOID_	imag_mem	( int x, int y, int width, int height, void far *pfar );

UNS__ 	qmemimag	( int dx, int dy );
VOID_	qrdimag		( int x, int y, int width, int height, void far *pfar );
VOID_	qwrimag		( int x, int y, void far *pfar );

VOID_   zoom2           ( int xs, int ys, int dx, int dy, int xd, int yd );
VOID_   zoom4           ( int xs, int ys, int dx, int dy, int xd, int yd );
VOID_   zoom4s          ( int xs, int ys, int dx, int dy, int xd, int yd );
VOID_   zoom8s          ( int xs, int ys, int dx, int dy, int xd, int yd );
VOID_   zoom8ss         ( int xs, int ys, int dx, int dy, int ox, int oy,
                         int xd, int yd, int color );

VOID_   setrwpage       ( int ireadpage, int iwritepage );
VOID_   setvpage        ( int visualpage );
VOID_   setrplane       ( int rplane );
VOID_   setwplane       ( int wplane );

VOID_   wrpixel         ( int x, int y, int color );
INT__   rdpixel         ( int x, int y );

VOID_   vrwait          ( int counter );

VOID_   scroll          ( int x, int yso, int ydi, int width, int height );
VOID_	scrollh		( int xso, int y, int xdi, int width, int height );
VOID_   savblock        ( int xs, int ys, int xd, int yd, int dx, int dy );

INT__   textread        ( int x, int y, int c, int bc, int len, char far *pfar);

VOID_	vtext		( int x, int y, int mas, int orient, Vfont far *pfar );

VOID_   screenwidth     ( int width );
VOID_   screenpan       ( int newx, int newy );

VOID_   circleout       ( int x, int y, int radius, int flag );
VOID_   circleoutf      ( int x, int y, int radius );
VOID_   circlemode      ( int mode );

/****************************************************************/

VOID_   cursorXOR       ( int x, int y );
VOID_   cursorPUT       ( int x, int y );
VOID_   cursorPUToff    ( void );
VOID_   cursor_color    ( int color, int colorBG );
VOID_   cursor_define   ( int xoffset, int yoffset, int far *pointc );

VOID_   curwindowXY     ( int far *x, int far *y );
VOID_   curwindow       ( int xmin, int ymin, int xmax, int ymax );

VOID_	cursorMASK	( int index );

/****************************************************************/

CHAR_	itoap		( int k, int len );
INT__	step		( int k, int mul, int div );

/****************************************************************/

VOID_   play            ( char far *string );
VOID_   playstop        ( void );
VOID_   playcikl        ( int c );
VOID_   playwait        ( int w );

/****************************************************************/

INT__   mouseon         ( int COMport );
VOID_   mouseoff        ( void );
VOID_   mouseXY         ( int far *pointx, int far *pointy );
INT__   mouseK          ( void );
INT__   mousehit        ( void );
VOID_   mousecall       ( int set_reset, void (far *fpoint)( void ), void far *point);
INT__	mouseKP		( void );

VOID_   kbdclr          ( void );
VOID_	kbddef		( void far *point );
INT__	kbdK		( void );
INT__	kbdhit		( void );
INT__	kbdlast		( void );
INT__	kbdKP		( void );

/****************************************************************/

VOID_	t_cursoron	( int xpos, int ypos );
VOID_	t_cursoroff	( void );
VOID_	t_cur_color	( int color );

VOID_	t_color		( int color );
VOID_	t_bgcolor	( int bgcolor );
VOID_	t_window	( int xoff, int yoff, int dx, int dy );
INT__	t_getcolor	( void );
VOID_	t_init		( char color );

VOID_	t_scrollUP	( void );
VOID_	t_scrollDOWN	( void );
VOID_	t_scrollLEFT	( void );
VOID_	t_scrollRIGHT	( void );
VOID_	t_delh		( int y );
VOID_	t_delw		( int x );

VOID_	t_char		( int x, int y, int color_char );

VOID_	t_string	( int x, int y, char far *pointer );

VOID_	t_TTY		( int cchar );
VOID_	t_gotoXY	( int x, int y );
INT__	t_getXpos	( void );
INT__	t_getYpos	( void );
VOID_	t_TTY_cur	( int set_reset );

LONG_   t_memimag       ( int dx, int dy );
VOID_   t_rdimag        ( void far *pfar );
VOID_   t_wrimag        ( void far *pfar );



VOID_   swapblock        ( int, int, int, int, int, int);

#ifdef __cplusplus
}
#endif

/****************************************************************/

#undef    INT__
#undef    VOID_
#undef    LONG_
#undef    CHAR_
#undef    UNS__

/***************************************************************
end of header           B W G  . H     17.02.1992
****************************************************************/
