#include "master.h"

#define MAX_COMM 2

extern char savename[15];
extern char LoadExt[40];
extern char AutoLoadPal[20];

char *CommentarySymbol=";#";
int CurLine=0;

void PrepareString(char *);

char *Boolean[]={
"False",
"True"
};

int IsValue(char *s,long *vv)
{

if(stricmp(s,"True")==0) { *vv=1; return 0; }
if(stricmp(s,"False")==0) { *vv=0; return 0; }

if(stricmp(s,"Yes")==0) { *vv=1; return 0; }
if(stricmp(s,"No")==0) { *vv=0; return 0; }


long v=0;
char *endptr;

v=strtol(s,&endptr,0);

if((*endptr!=0))
{
v=strtol(s,&endptr,16); // Is Hex?

if((*endptr!=0))
{
*vv=0;
return -1;
}

}

*vv=v;

return 0;
}


int PrepareValue(char *v)
{
PrepareString(v);

if(v[0]=='=') v[0]=' ';

PrepareString(v);

if(v[0]==0)
{
printf("CFG Error: Nothing after '=' in line %d;\n",CurLine);
return -1;
}

return 0;
}

int ParseString(char *s,char *Comm,char *ValueStr)
{
Comm[0]=0;
ValueStr[0]=0;

int l=strlen(s);

if(l==0) return -1;

for(int off=0; off<l; off++)
  if((isalpha(s[off]))==0) break;

if(off==(l-1))
{
printf("CFG Error: Only one word in line %d;\n",CurLine);
return -1;
}

strncpy(Comm,s,off);
Comm[off]=0;
strcat(ValueStr,s+off);

return 0;
}

void DeleteAllComms(char *s)
{
int l=strlen(s);

if(l==0) return;

for(int kk=0; kk<l; kk++)
for(int i=0; i<MAX_COMM; i++)
 if(s[kk]==CommentarySymbol[i]) { s[kk]=0; return; }

}



int IsCommentary(char *s)
{
if(s[0]==0) return 0;

for(int i=0; i<MAX_COMM; i++)
 if(s[0]==CommentarySymbol[i]) return -1;

return 0;
}

void DeleteRight(char *s)
{
int i;

i=strlen(s);
i--;

while((isspace(s[i]))!=0) i--;

s[i+1]=0;
}



void PrepareString(char *s)
{
char str2[160];

str2[0]=0;

int i=0,i2=0,l=0;

l=strlen(s);

while((isspace(s[i]))!=0) i++;

strcpy(str2,s+i);

s[0]=0;
strcat(s,str2);
}


void CFG_Save(char*Name)
{
char buf[2048];
char str[160];
long v;

FILE *out;

if((out=fopen(Name,"w+"))==NULL)
{
   printf("Unable to creat config file: %s;\n",Name);
   getch();
   return;
}

if(setvbuf(out, buf, _IOFBF, 2048)!=0)
{
printf("Failed to set up buffer for config file: %s;\n",Name);
getch();
}

fprintf(out,"; GDS Configuration File\n");
fprintf(out,"StartSizeX=%d\n",editx);
fprintf(out,"StartSizeY=%d\n",edity);
fprintf(out,"DebugMode=%s\n",Boolean[debug]);
fprintf(out,"CellX=%d\n",cellx);
fprintf(out,"CellY=%d\n",celly);

fprintf(out,"CopyRight=%s\n",Boolean[_copyright]);
fprintf(out,"ExitPrompt=%s\n",Boolean[exitprompt]);
fprintf(out,"LastEditSprite=%s\n",loadname);
fprintf(out,"LoadExt=%s\n",LoadExt);
fprintf(out,"AutoLoadPal=%s\n",AutoLoadPal);
fprintf(out,"VideoMode=%d\n",_vmode);

fclose(out);
}


void CFG_Load(char *Name)
{
char buf[2048];
char str[160];
long v;

FILE *in;

if((in=fopen(Name,"r"))==NULL)
{
   printf("Unable to open config file: %s;\n",Name);
   getch();
   return;
}

if(setvbuf(in, buf, _IOFBF, 2048)!=0)
{
printf("Failed to set up buffer for config file: %s;\n",Name);
getch();
}

char Comm[160];
char ValueStr[160];

while(!feof(in))
{
if(fgets(str,140,in)==0) break;

CurLine++;

PrepareString(str);

if(IsCommentary(str)==-1) continue;

DeleteAllComms(str);
DeleteRight(str);

if(ParseString(str,Comm,ValueStr)==-1) continue;

if(PrepareValue(ValueStr)==-1) continue;

v=0;

if(strcmpi(Comm,"StartSizeX")==0) {
if(IsValue(ValueStr,&v)==-1)
 printf("CFG Error: Bad value %s for %s in line %d;\n",ValueStr,Comm,CurLine);

startsizex=v;
 continue;
};

if(strcmpi(Comm,"StartSizeY")==0) {
if(IsValue(ValueStr,&v)==-1)
 printf("CFG Error: Bad value %s for %s in line %d;\n",ValueStr,Comm,CurLine);

startsizey=v;
 continue;
};

if(strcmpi(Comm,"DebugMode")==0) {
if(IsValue(ValueStr,&v)==-1)
 printf("CFG Error: Bad value %s for %s in line %d;\n",ValueStr,Comm,CurLine);

debug=v;
 continue;
};


if(strcmpi(Comm,"CellY")==0) {
if(IsValue(ValueStr,&v)==-1)
 printf("CFG Error: Bad value %s for %s in line %d;\n",ValueStr,Comm,CurLine);

celly=v;
 continue;
};


if(strcmpi(Comm,"CellX")==0) {
if(IsValue(ValueStr,&v)==-1)
 printf("CFG Error: Bad value %s for %s in line %d;\n",ValueStr,Comm,CurLine);

cellx=v;
 continue;
};


if(strcmpi(Comm,"CopyRight")==0) {
if(IsValue(ValueStr,&v)==-1)
 printf("CFG Error: Bad value %s for %s in line %d;\n",ValueStr,Comm,CurLine);

_copyright=v;
 continue;
};

if(strcmpi(Comm,"VideoMode")==0) {
if(IsValue(ValueStr,&v)==-1)
 printf("CFG Error: Bad value %s for %s in line %d;\n",ValueStr,Comm,CurLine);

_vmode=v; modestart=5;
 continue;
};


if(strcmpi(Comm,"ExitPrompt")==0) {
if(IsValue(ValueStr,&v)==-1)
 printf("CFG Error: Bad value %s for %s in line %d;\n",ValueStr,Comm,CurLine);

exitprompt=v;
 continue;
};

if(strcmpi(Comm,"LastEditSprite")==0) {
loadname[0]=0; strcat(loadname,ValueStr);
savename[0]=0; strcat(savename,ValueStr);
continue;
}

if(strcmpi(Comm,"LoadExt")==0) {
LoadExt[0]=0; strcat(LoadExt,ValueStr);
continue;
}

if(strcmpi(Comm,"AutoLoadPal")==0) {
AutoLoadPal[0]=0; strcat(AutoLoadPal,ValueStr);
continue;
}


printf("CFG Warning: Unsupported command %s in line %d;\n",Comm,CurLine);
getch();

}

fclose(in);
}


int CheckVariable(int var,int max,char *name)
{

if(var<0)
{
printf("CheckVariable: Variable '%s' must be above or equal to zero!\n",name);
getch();
return -1;
}

if(var>max)
{
printf("CheckVariable: Variable '%s' must be below or equal to %d!\n",name,max);
getch();
return -1;
}

return 0;
}
