#include "dos.h"
#include "io.h"
#include "dir.h"
#include "stdio.h"
#include "stdlib.h"
#include "conio.h"
#include "fcntl.h"
#include "string.h"

#include "sprite.h"
#include "font.h"

FONT_HEADER font_header={ 0 };
FONT_CHAR_TABLE font_char_table={ 0 };
SPRITE_ITEM font_sprite[256];

int main(int argc, char **argv)
{
int h;

// It's important:
 h=open(argv[0],O_RDONLY);
 close(h);

 strcat(font_header.LM,"Lena M." );

puts("FoNT UTILity Version 3.0 BY Alex Chudnovsky");
puts("Copyright (C) Mythical Software Group 1993/94");
puts(" For VGA 256 colors fonts only.");

if(argc==1) {  help(); return 1;  }

strupr(argv[1]);

if(strlen(argv[1])>1)
{

printf(" ERROR: Second argument '%s' must be one character length\n\r",argv[1]);
return -1;

}

switch(*argv[1]) {

case 'C': creatfont(argc,argv);
	  printf("Font '%s' successfully created\n\r", argv[2]);
	  return 0;

case 'I': FontInfo(argc,argv);   return 0;

case 'D': DeleteChar(argc,argv); return 0;

case 'A': AddChar(argc,argv);    return 0;

case 'S': ShowChar(argc,argv);   return 0;

case 'X':

	  error("Not supported function yet"); 

default:  printf("Unknown command: '%s'\n\r",argv[1]);

};

return 0;

}


void help(void)
{

puts(" Usage:  FNTUTIL.EXE command [File1.FNT] [File2.SPR] [option]");
puts("    A -- Add char from .SPR to .FNT");
puts("    C -- Creat .FNT file");
puts("    D -- Delete char inside .FNT");
puts("    I -- Info about containing .FNT");
puts(" *  O -- Optimize data relocation in .FNT");
puts("    S -- Show string using font .FNT");
puts(" *  X -- eXclude char from .FNT to .SPR");

}


void creatfont(int ac,char **av)
{
int h;

if(ac<3) error("Extra filename to creat font required");

makeextention(av[2],".FNT");

if( (h=_creat(av[2],FA_ARCH))==-1) {
printf("ERROR: Can't creat '%s'\n\r",av[2]);
exit(1);
				   }

font_header.version=FONT_VERSION;
font_header.imagesize=0;
font_header.ylen=0;
font_header.xlen=0;
font_header.vmode=0;


if( (_write(h, &font_header, sizeof(FONT_HEADER)))==-1)
     error("Can't write font header");

if( (_write(h, &font_char_table, sizeof(FONT_CHAR_TABLE)))==-1)
     error("Can't write font char definition table");

     close(h);
}


void error(char *err)
{
printf(" ERROR: %s; \n\r",err);
exit(3);
}


void makeextention(char *av,char *e)
{
int flags;
char drive[10], dir[100], file[20], ext[10];

drive[0]=0;
dir[0]=0;
file[0]=0;
ext[0]=0;

flags=fnsplit(av, drive, dir, file, ext);

strupr(av);

if(strlen(ext)==0) {
strcat(av,e);
		   }
else return;
}


void FontInfo(int ac,char **av)
{
int h;
int i,sum;
int k;

if(ac<3) error("Extra filename to make font info required");

makeextention(av[2],".FNT");

  if( (h=open(av[2],O_RDWR))==-1)
{
printf("ERROR: Can't open %s\n\r",av[2]);
exit(1);
}

 if( (_read(h, &font_header, sizeof(FONT_HEADER)))==-1)
    error("Can't _read font header");

if(strcmp(font_header.LM,"Lena M.")!=0)
    error("Incorrect font format");

if(font_header.version!=FONT_VERSION)
    error("Incorrect font version");

if( (_read(h, &font_char_table, sizeof(FONT_CHAR_TABLE)))==-1)
    error("Can't read font char definition table");

//printf("Processing %s:\n\r",av[2]);

printf("1. Chars presented:  ");

sum=0;
for(i=0; i<256; i++) { if(font_char_table.offset[i]!=0) sum++; }

printf("%d\n\r",sum);

printf("2. Lenght [X]:       %d\n\r",font_header.xlen);
printf("3. Width  [Y]:       %d\n\r",font_header.ylen);
printf("4. Image Size:       %d\n\r",font_header.imagesize);

puts(" Defined chars:");
for(i=0; i<4; i++)  {
printf("\t");
for(k=0; k<64; k++) {
if((font_char_table.offset[i*64+k])==0) putch('.');
else                                     putch(i*64+k);

		    }
printf("\n\r");
		    }

close(h);

}


	  void AddChar(int ac,char **_av)
{
SPR_HDR sprite_header;
int font,sprite;
int i;
char av[40][20];
void *sprdata;
char key,place;
long sprsize=0;

 for(i=0; i<ac; i++) { av[i][0]=0; strcat(av[i],_av[i]); }


// FNTUTIL font a.spr A


if(ac<4) error("Extra .SPR filename and letter to place it required");

;
;
;

if(ac==4)
{

printf("Enter a char to place this font item: "); *av[4]=getche();
puts("");

}

else {
if(strlen(av[4])>1)
       error("Fifth argument must be equal a letter");
     }

char CharToPlace=*av[4];

 makeextention(av[2],".FNT");
 makeextention(av[3],".SPR");

  if( (font=open(av[2],O_RDWR))==-1)
{
printf("ERROR: Can't open %s\n\r",av[2]);
exit(1);
}



  if( (sprite=open(av[3],O_RDWR))==-1)
{
printf("ERROR: Can't open %s\n\r",av[3]);
close(font);
exit(1);
}

// Read font data:
 if( (_read(font, &font_header, sizeof(font_header)))==-1)
     error("Can't read font header");

if(strcmp(font_header.LM,"Lena M.")!=0)
    error("Incorrect font format");

if(font_header.version!=FONT_VERSION)
    error("Incorrect font version");


if( (_read(font, &font_char_table, sizeof(font_char_table)))==-1)
     error("Can't read font char definition table");


// Check if already defined:
if((font_char_table.offset[(*av[4])])!=0) {

 printf(" ERROR: Letter '%c' already defined in font\n\r",*av[4]);
 close(font);
 close(sprite);
 exit(4);

					   }


// Read SPRITE data
if( (_read(sprite, &sprite_header, sizeof(sprite_header)))==-1)
     error("Can't read sprite header");

if(sprite_header.Version!=SPRITE_VERSION)
     error("Incorrect sprite file version");

int CharsNum=charnum();


   // Does it first letter to write font file?
if( (font_header.xlen==0) && (font_header.ylen==0)) {

printf("Attention: You are trying to define first letter in that font\n\r");
  puts("  Letter characteristics are:");
printf("  Size X: %d\n\r",(int) sprite_header.SizeX);
printf("  Size Y: %d\n\r",(int) sprite_header.SizeY);
printf("  Data size: %d\n\r",sprite_header.DataLen);
printf("     Confirm? [YN]");

if(getyn()!=0) {
// No
term:

close(font);
close(sprite);
puts("Adding terminated by user.");
exit(6);

	       }

// Yes, making coordinates & sizes equal
font_header.xlen=sprite_header.SizeX;
font_header.ylen=sprite_header.SizeY;
font_header.imagesize=sprite_header.DataLen;
font_header.vmode=sprite_header.VideoMode;
}


if( (font_header.xlen!=sprite_header.SizeX) ||
    (font_header.ylen!=sprite_header.SizeY)) {

printf("Sorry, but font sizes (x=%d and y=%d) and sprite sizes (x=%d and y=%d)\
are not the same! ",font_header.xlen,font_header.ylen,sprite_header.SizeX,
sprite_header.SizeY);
goto term;

					      }

// Allocating memory and Reading sprite data
if((sprdata=malloc(sprite_header.DataLen))==0)
    error("Not enough memory to load sprite data");

if( (_read(sprite,sprdata,sprite_header.DataLen))==-1) {

close(sprite);
close(font);
error(" Can't read sprite data");
exit(5);
						   }


font_char_table.offset[(*av[4])]=lseek(font,0,SEEK_END);
font_header.imagesize=sprite_header.DataLen;


// Here save loaded data to font file:


lseek(font,0,SEEK_SET);
// Write font header, char table ...
if( (_write(font, &font_header, sizeof(font_header)))==-1)
     error("Can't write font header");

if( (_write(font, &font_char_table, sizeof(font_char_table)))==-1)
     error("Can't write font char definition table");

lseek(font,font_char_table.offset[(*av[4])],SEEK_SET);
_write(font,sprdata,font_header.imagesize);

free(sprdata);
close(font);
close(sprite);

if(CharToPlace!=(*av[4]))
{
printf("Abnormal condition: CharToPlace=%c, but *av[4]=%c\n\r",CharToPlace,*av[4]);
getch();
return;
}

if((CharsNum+1)!=charnum())
{
printf("Abnormal condition: CharsNum+1=%d, but charnum()=%d\n\r",CharsNum+1,charnum());
getch();
return;
}

printf("Added character '%c', now characters in font: %d.\n\r",*av[4],charnum());
}


int getyn(void)
{
char key;

go:
switch(getch()) {

case 'y':
case 'Y':   printf(" Yes\n\r"); return 0;

case 'n':
case 'N':   printf(" No\n\r");  return 1;

default: break;

};

goto go;

}

void DeleteChar(int ac,char **_av)
{
int i;
char av[40][20];
int font;

if(ac<3) error("Font name required;");
if(ac<4) error("You have to point out letter to delete;");

for(i=0; i<ac; i++) { av[i][0]=0; strcat(av[i],_av[i]); }
makeextention(av[2],".FNT");

  if( (font=open(av[2],O_RDWR))==-1)
{
printf(" ERROR: Can't open %s\n\r",av[2]);
exit(1);
}


// Read font data:
 if( (_read(font, &font_header, sizeof(font_header)))==-1)
  { close(font);   error("Can't read font header");  }

if(strcmp(font_header.LM,"Lena M.")!=0)
  { close(font);  error("Incorrect font format");  }

if(font_header.version!=FONT_VERSION)
  { close(font);   error("Incorrect font version"); }


if( (_read(font, &font_char_table, sizeof(font_char_table)))==-1)
  { close(font);   error("Can't read font char definition table"); }

if((font_char_table.offset[(*av[3])])==0) {

 printf("ERROR: Letter '%c' not defined in font\n\r",*av[3]);
 close(font);
 exit(4);

					   }

font_char_table.offset[(*av[3])]=0;


if(charnum()==0) {
puts("Warning: Font now is empty!");

		 }


// Write font header, char table ...

lseek(font,0,SEEK_SET);
if( (_write(font, &font_header, sizeof(font_header)))==-1)
     error("Can't write font header");

if( (_write(font, &font_char_table, sizeof(font_char_table)))==-1)
     error("Can't write font char definition table");

close(font);
printf("Letter '%c' deleted.\n\r",*av[3]);
}

int charnum(void)
{
int sum,i;

sum=0;
for(i=0; i<256; i++) { if(font_char_table.offset[i]!=0) sum++; }

return sum;
}


void ShowChar(int ac, char **av)
{
if(ac<4) error("Extra .FNT name and strings to show required");

LoadFont(av[2]);

asm {
mov ax,13h
int 10h
};

int xs;

for(int i=3; i<=ac; i++)
{

xs=320/2-strlen(av[i])*font_header.xlen/2;
StringOutXY(xs,10+font_header.ylen*(i-3), av[i]);

}


getch();

asm {
mov ax,3
int 10h
};

printf("Shown data from %d arguments;\n\r",ac-3);

}


void StringOutXY(int x, int y, char *s)
{
int i;
int len=strlen(s);

for(i=0; i<len; i++)
{
CharOutXY( x+font_header.xlen*i, y, s[i]);
}

}



  // Works with current font:
void CharOutXY(int x, int y, char c)
{

if(font_char_table.offset[c]==0) {
  printf("Undefined symbol '%c' in font (press a key)\n\r",c);
  getch();
  return;
				  }
showsprite(x,y,&font_sprite[c]);

}


void LoadFont(char *_av)
{
char av[100];
int font;


av[0]=0;
strcat(av,_av);

makeextention(av,".FNT");

   if( (font=open(av,O_RDWR))==-1)
{
printf("ERROR: Can't open %s\n\r",av);
exit(1);
}


// Read font data:
if( (_read(font, &font_header, sizeof(font_header)))==-1)
  { close(font);  error("Can't read font header");  }

if(strcmp(font_header.LM,"Lena M.")!=0)
  { close(font);  error("Incorrect font format");  }

if(font_header.version!=FONT_VERSION)
  { close(font);  error("Incorrect font version"); }


if( (_read(font, &font_char_table, sizeof(font_char_table)))==-1)
  { close(font);  error("Can't read font char definition table"); }

// Loading...
int i;
int fontsys=sizeof(font_char_table)+sizeof(font_header);

for(i=1; i<256; i++) {

if(font_char_table.offset[i]==0) continue;
else {

int off=lseek(font,font_char_table.offset[i],SEEK_SET);
if(off==-1) { puts("Lseek error!"); }

if((font_sprite[i].buf=malloc(font_header.imagesize))==0)
   { close(font); error("Can't allocate memory!"); }

int err;

err=_read(font, font_sprite[i].buf,  font_header.imagesize);
font_sprite[i].sizex=font_header.xlen;
font_sprite[i].sizey=font_header.ylen;
if(err==-1) { printf("ERROR: Can't load symbol '%c'\n\r",(char) i); getch(); }

     }

		     }

close(font);
}

void ShowVGASprite(int x,int y,int dx,int dy,char *data);

  void showsprite(int x,int y, SPRITE_ITEM *s)
{

ShowVGASprite(x,y,s->sizex,s->sizey,(char *) s->buf);

}

void ShowVGASprite(int x,int y,int dx,int dy,char *_data)
{

int DeltaX=dx;
int DeltaY=dy;
int SubDelta=320-DeltaX;

asm {

pusha
push es
push ds
cld

mov ax,y
mov bx,320
mul bx

mov bx,x
add ax,bx

mov di,ax

mov ax,0a000h
mov es,ax
// ES:DI on first byte:

mov cx,DeltaY
mov bx,DeltaX
mov dx,SubDelta
mov ah,255 // Transparent color:
lds si,_data

};

Loop_Y:

asm {

push cx

mov cx,bx

};

LoopX:

asm {

lodsb
cmp al,ah
je Next
stosb
loop LoopX
add di,dx

pop cx
loop Loop_Y

pop ds
pop es
popa

};

return;

Next:

asm {

inc di
loop LoopX

add di,dx

pop cx
loop Loop_Y

pop ds
pop es
popa

};

}


