/*

	      Font Utility Header File Version 1.0
	      Copyright (C) Mythical Sotware Group

*/

#define FONT_VERSION    3
#define SPRITE_VERSION  10

typedef struct tagFONT_HEADER {

char LM[8];         // Signature
char version;
unsigned xlen;
unsigned ylen;
unsigned imagesize; // In bytes
int vmode;

} FONT_HEADER;


typedef struct tagFONT_CHAR_TABLE {

long offset[256];

} FONT_CHAR_TABLE;


typedef struct _FONT_CHAR_ {

void *data;   // Char definition data
void *mask;   // If any

} FONT_CHAR;


// Sprite Header
typedef struct _SPRITE_HEADER {

   char nk[2];
   char version;
   char type;
   int heigth;
   int length;
   char mode;
   int size;

} SPRITE_HEADER;

void help(void);
void creatfont(int,char **);
void FontInfo(int,char **);
void AddChar(int,char **);
void DeleteChar(int,char **);
void error(char *);
void makeextention(char *,char *);
int  getyn(void);
int  getfreeplace(void);    // Returns absolute place of new symbol data
int  charnum(void);         // Number defined chars in font
void ShowChar(int,char **);


// Font functions:

typedef struct _FONT_ {

FONT_HEADER      head;
FONT_CHAR_TABLE  table;

} FONT;


typedef struct _SPRITE_ITEM {
int sizex,sizey;
void  *buf;
void  *mask;
}  SPRITE_ITEM;


void showsprite(int x, int y, SPRITE_ITEM *);
void initsprite(int x, int y, SPRITE_ITEM *);

void CharOutXY(int,int,char);
void StringOutXY(int,int,char *);
void LoadFont(char *);

int  FNTLoadFont(FONT *,char *);
void FNTReleaseFont(FONT *);
void FNTCharOutXY(FONT *,int,int,char);
void FNTStringOutXY(FONT *,int,int,char *);
