/*


	 Sprite Header File Version 2.0 BY Alex Chudnovsky
	 Copyright (C) Mythical Software Group


*/


// Sprite file header:

typedef struct _SPR_HDR_ {

char NK[2];      // Signature of Sprite Editor: 'NK';
char Version;
char VideoMode;
char Type;
int  SizeX;
int  SizeY;
int  DataLen;    // Lengh of base Data: mustn't be equal to zero;
int  MaskLen;    // Length of Mask: If zero -> no mask in sprite;

} SPR_HDR;


typedef struct _SPRITE_ {

int   x,y;
char  dx,dy;
char  CacheMemHandle;  // If any;
char *Data;
char *Mask;
char *SaveMem;         // If any;

}  SPRITE;



// Sprite manitulation routines:

int  LoadSprite(char *,SPRITE *);
void ReleaseSprite(SPRITE *);
void DrawSprite(SPRITE *);
void DrawSpriteAt(int,int,SPRITE *);
void DrawSpriteData(SPRITE *);
void DrawSpriteMask(SPRITE *);


