/*
  MapDesigner:   ᫠  ᤥ MapEditor  ⠢
  Dune3.
*/



#include "graphics.h"
#include "stdlib.h"
#include "stdio.h"
#include "conio.h"
#include "time.h"
#include "string.h"
#include "fcntl.h"
#include "dos.h"
#include "stdarg.h"
#include "ctype.h"
#include "process.h"
#include "dir.h"
#include "io.h"
#include "pcxlib.h"
#include "alloc.h"
#include "bwg.h"
#include "tkeys.h"
#include "gamekit.h"
#include "mem.h"
#include "objects.h"
#include "objects2.h"
#include "video.h"
#include "sprite.h"
#include "library.h"
#include "backgrnd.h"

// Default Map Designer values:
int DinamicsFlag=0,MapItemsNumber=1000,NumberOfStatics=900,MaxTiles=500;

void DrawRectVirtualPage(int VirtX,int VirtY,char *Rect,char RectSizeX,\
char RectSizeY,char RectX,char RectY,char RectDX,char RectDY);
void VirtualClear(int,int,int,int);
void DrawTileAt(int x,int y,TILE *tile);
void PutVirtualTileAt(int x,int y,TILE *tile);

typedef struct _MAP_HDR_ {

char SL[2];
char Descr[30];
char SprLib[13];
int  Number;
int SizeX;
int SizeY;

} MAP_HDR;

typedef struct _SLIB_HDR_ {

char SL[2];
char Descr[20];
int  Number; // Max number;

} SLIB_HDR;


typedef struct _SLIB_ITEM_ {

char FileName[13];

} SLIB_ITEM;

char far *SaveScr;

int       MapFlag=-1;

MAP_HDR   CurMap;

TILE      WorkTile[500];
char      *TileFlags;
char      *TileAni;


#define DRAW 0
#define PUT  1

int IsTransparent(TILE *);


char MapName[40]="defmap.map";

int   CurEditTile=0;
int   ShowMapX=0,ShowMapY=0;
int   ETX=0,ETY=0;
int   StepX=16,StepY=16;
int   Items;
int   getfreemem(void);
void  CloseSpriteManager(void);
int   InitSpriteManager(void);
void  MP_Work(void);
void  makeextension(char *,char *);

#define MAP_DX 16*12
#define MAP_DY 16*9

int MAP_X=64;
int MAP_Y=28;

int CurPlane=0;

char DuneMap[10000];

// Checks: Is point (x,y) inside the rect (x1,y1,x2,y2)?

int IsInside(int x,int y,int x1,int y1,int x2,int y2)
{
if((x>=x1 && x<=x2) && (y>=y1 && y<=y2)) return 0;
else                                    return -1;
}

int IsRectIn(int x1,int y1,int x2,int y2,int Ex1,int Ey1,int Ex2,int Ey2)
{

if(IsInside(x1,y1,Ex1,Ey1,Ex2,Ey2)==-1) return -1;
if(IsInside(x1,y2,Ex1,Ey1,Ex2,Ey2)==-1) return -1;
if(IsInside(x2,y1,Ex1,Ey1,Ex2,Ey2)==-1) return -1;
if(IsInside(x2,y2,Ex1,Ey1,Ex2,Ey2)==-1) return -1;

return 0;
}

int IsOverl(int x1,int y1,int x2,int y2,int Ex1,int Ey1,int Ex2,int Ey2)
{

if(IsInside(x1,y1,Ex1,Ey1,Ex2,Ey2)==0) return 0;
if(IsInside(x1,y2,Ex1,Ey1,Ex2,Ey2)==0) return 0;
if(IsInside(x2,y1,Ex1,Ey1,Ex2,Ey2)==0) return 0;
if(IsInside(x2,y2,Ex1,Ey1,Ex2,Ey2)==0) return 0;

return -1;
}

int oldx=-1;
int oldy=-1;

void RedrawStatics(int pl)
{

int Ex1=MAP_X+ShowMapX;
int Ex2=Ex1+MAP_DX;
int Ey1=MAP_Y+ShowMapY;
int Ey2=Ey1+MAP_DY;
int Spr;

VirtualClear(MAP_X,MAP_Y,MAP_X+MAP_DX,MAP_Y+MAP_DY);

for(int i=ShowMapY; i<(ShowMapY+MAP_DY/16); i++)
for(int j=ShowMapX; j<(ShowMapX+MAP_DX/16); j++)
{
Spr=DuneMap[j+i*98];

PutVirtualPage(MAP_X+(j-ShowMapX)*16,MAP_Y+(i-ShowMapY)*16,16,16,WorkTile[Spr].Data);
}

}



void RedrawPlane(int pl)
{
RedrawStatics(pl);
}

void RealRedrawCurPlane(void)
{
RedrawPlane(CurPlane);
}

void RedrawCurPlane(void)
{
RedrawPlane(CurPlane);
}

int PlaceUniqueMapItem(void)
{
}


int PlaceMapItem(void)
{
DuneMap[ETX/16+(ETY/16)*98]=CurEditTile;
//printf("\n%d:%d; ",ETX/16,ETY/16);
return 0;
}

void ShowVirtMap(void)
{
VirtualPage2Screen(MAP_X,MAP_Y,MAP_DX,MAP_DY);
}

int GetItems(void)
{
return 1;
}

void ShowStatus(void)
{
/*
if(TileFlags[CurEditTile]==0)
Text8f(5,1,LIGHTBLUE,15,"No Tile on %d;                        ",CurEditTile);
else
{
Text8f(5,1,LIGHTBLUE,15,"Tile: %d;ETX: %d,ETY: %d;Steps: %d,%d;  ",CurEditTile,ETX,ETY,StepX,StepY);
}

Text8f(5,180,LIGHTBLUE,15,"Plane: %d; Items: %d   ",CurPlane,Items);
*/
}

void ShowEditTile(void)
{
ShowVirtMap();

if(TileFlags[CurEditTile]!=0)
{
DrawTileAt(MAP_X+ETX-ShowMapX*16,MAP_Y+ETY-ShowMapY*16,&WorkTile[CurEditTile]);
}

}

void FreeTiles(void)
{
for(int i=0; i<500; i++)
 ReleaseTile(&WorkTile[i]);
}


int SwapH;


int c_break(void)
{

asm {
mov ax,3
int 10h
}

puts("Ctrl-Break pressed: Emergency exit.");
exit(10);
return 0;
}

void MP_Designer(void)
{

ctrlbrk(c_break);


MAP_X=160-MAP_DX/2;
MAP_Y=100-MAP_DY/2;

//printf("%d,%d",MAP_X,MAP_Y);

if(InitSpriteManager()==-1) goto No_Mem;

if((SaveScr=(char*) malloc(64000U))==0)
{
No_Mem:
MessageBox("Out of memory",1);
return;
}

mouse_hide();
GetBlock(0,0,40,200,SaveScr);

VideoSetFillStyle(0,0);
VideoBar(0,0,319,199);
VideoSetFillStyle(0,15);

VideoSetFillStyle(0,0);
VideoBar(MAP_X,MAP_Y,MAP_X+MAP_DX,MAP_Y+MAP_DY);
VideoSetColor(LIGHTBLUE);
VideoRectangle(MAP_X-1,MAP_Y-1,MAP_X+MAP_DX+1,MAP_Y+MAP_DY+1);

VirtualClear(MAP_X,MAP_Y,MAP_X+MAP_DX,MAP_Y+MAP_DY);
mouse_show();

ShowMapX=0;
ShowMapY=0;
CurEditTile=0;
MapFlag=-1;
TileFlags[0]=0;
char Path[20];
Path[0]=0;

if((SwapH=creattemp(Path,0))==-1)
{
MessageBox("Unable to creat swap file!",1);
}
else
{
_write(SwapH,SaveScr,64000U);
free(SaveScr);
SaveScr=0;
}

//WorkTile=(TILE *) malloc(MaxTiles*sizeof(TILE));
//if(WorkTile==0) goto No_Mem;


TileFlags=(char *) malloc(MapItemsNumber+100);
if(TileFlags==0) goto No_Mem;

TileAni=(char *)malloc(MapItemsNumber+100);
if(TileAni==0) goto No_Mem;

MP_Work();

CloseSpriteManager();

if(MapFlag!=-1) { FreeTiles(); }
MapFlag=-1;

if(SaveScr==0)
{

if((SaveScr=(char*) malloc(64000U))==0)
{
MessageBox("Out of memory",1);
}
else {
lseek(SwapH,0L,SEEK_SET);
_read(SwapH,SaveScr,64000U);
close(SwapH);

mouse_hide();
PutBlock(0,0,40,200,SaveScr);
mouse_show();

free(SaveScr);

     }

}

free(TileFlags);
free(TileAni);

unlink(Path);
}

int IsTransparent(TILE tile)
{

for(int y=0; y<tile.dy; y++)
for(int x=0; x<tile.dx; x++)
{
if(tile.Data[y*tile.dx+x]==255) return DRAW;
}

return PUT;
}


void MP_LoadMap(void)
{
MapName[0]=0;
int h,h2;

if((getfile("*.MAP","Load MAP",MapName))==0) { return; }

if((h=_open(MapName,O_RDWR))==-1)
{
puts("Unable to open Map!");
MessageBox("Unable to open Map!",1);
return;
}

SLIB_HDR  sl;
SLIB_ITEM item;

if(MapFlag!=-1) FreeTiles();

if((h2=_open("dune3.sl",O_RDWR))==-1)
{
MessageBoxf(1,"Unable to open Map SprLib:|'DUNE3.SL'");
MapFlag=-1;
close(h);
return;
}

if(_read(h,DuneMap,98*98)==-1)
{
MessageBoxf(1,"Unable to read map data!");
MapFlag=-1;
return;
}

if(_read(h2,&sl,sizeof(SLIB_HDR))==-1)
{
printf("Unable to read sprite library header!");
MapFlag=-1;
return;
}

int LoadedTiles=0;

int Mem1,Mem2;

Mem1=getfreemem();

for(int j=0; j<500; j++)
{

if(_read(h2,&item,sizeof(SLIB_ITEM))==-1)
{
printf("Error reading sprite library item!");
MapFlag=-1;
return;
}

strupr(item.FileName);

if(strcmp(item.FileName,"__NONAME.SPR")==0)
{
TileFlags[j]=0;
continue;
}

if(LoadTile(item.FileName,&WorkTile[j])==-1)
{
printf("Unable to load tile: '%s'",item.FileName);
MessageBoxf(1,"Unable to load tile:|'%s'|%s",item.FileName,sys_errlist[errno]);
MapFlag=-1;
break;
}

TileAni[j]=IsTransparent(WorkTile[j]);

TileFlags[j]=100;
LoadedTiles++;
}

Mem2=getfreemem();
MapFlag=0;
MessageBoxf(0,"Tiles Loaded: %d|Used mem: %dk",LoadedTiles,Mem1-Mem2);

ShowEditTile();

close(h);
Items=GetItems();
ShowMapX=0;
ShowMapY=0;
}



void MP_LoadSprites(void)
{
int h,h2;

SLIB_HDR  sl;
SLIB_ITEM item;

if((h2=_open("dune3.sl",O_RDWR))==-1)
{
MessageBoxf(1,"Unable to open Map SprLib:|'DUNE3.SL'");
MapFlag=-1;
close(h);
return;
}


if(_read(h2,&sl,sizeof(SLIB_HDR))==-1)
{
printf("Unable to read sprite library header!");
MapFlag=-1;
return;
}

int LoadedTiles=0;

int Mem1,Mem2;

Mem1=getfreemem();

for(int j=0; j<250; j++)
{

if(_read(h2,&item,sizeof(SLIB_ITEM))==-1)
{
printf("Error reading sprite library item!");
MapFlag=-1;
return;
}

strupr(item.FileName);

if(strcmp(item.FileName,"__NONAME.SPR")==0)
{
TileFlags[j]=0;
continue;
}

if(LoadTile(item.FileName,&WorkTile[j])==-1)
{
printf("Unable to load tile: '%s'",item.FileName);
MessageBoxf(1,"Unable to load tile:|'%s'",item.FileName);
MapFlag=-1;
break;
}

TileAni[j]=IsTransparent(WorkTile[j]);

TileFlags[j]=100;
LoadedTiles++;
}

Mem2=getfreemem();
MapFlag=0;
//MessageBoxf(0,"Tiles Loaded: %d|Used mem: %dk",LoadedTiles,Mem1-Mem2);

ShowEditTile();

close(h);
Items=GetItems();
ShowMapX=0;
ShowMapY=0;
}


void MP_CreatSprLib(void)
{
char Name[20];
Name[0]=0;

SLIB_HDR  map;
SLIB_ITEM item;

map.SL[0]='S';
map.SL[1]='L';

for(int i=0; i<13; i++)
 item.FileName[i]=0;

for(i=0; i<20; i++)
 map.Descr[i]=0;


strcat(item.FileName,"__NONAME.SPR");

mouse_hide();

WINDOW s(-1,-1,300,140,"Creat SprLib",DLG_FRAME);

s.ShowWindow();

InputLine il(s.x+120,s.y+25,Name,12, kbAltS);
InputLine il2(s.x+120,s.y+25+20,map.Descr,19, kbAltD);

BUTTON ok(s.x+10,s.y+110,80,20,"&OK",kbEnter);
BUTTON cancel(s.x+210,s.y+110,80,20,"&Cancel",kbEsc);

ok.Show();
cancel.Show();
il.Show();
il2.Show();
s.SetTextColor(0);
s.UString(10,25+5-13, "&SLIB to creat:");
s.UString(10,25+5-13+20, "&Description:");

mouse_show();

EVENT event;

event.keyboard=kbAltS;
il.ProcessEvent(&event);

go:

event=_GetEvent();
il.ProcessEvent(&event);
il2.ProcessEvent(&event);

if( (cancel.ProcessEvent(&event))==PRESSED) {
Ex:
					s.DeleteWindow();
					return;
					     }

if( (ok.ProcessEvent(&event))==PRESSED)
{
int h;
makeextension(Name,".SL");

if((h=_creat(Name,FA_ARCH))==-1)
 { MessageBox("Unable to creat SLIB!",1); goto go; }

map.Number=500;

_write(h,&map,sizeof(map));

for(int i=0; i<map.Number; i++)
 _write(h,&item,sizeof(item));

 close(h);
goto Ex;
}

goto go;

}

char *SPR_Ext="*.SPR     ";
char Empty2[20];

void MP_BrowseSprLib(void)
{
char SL_Name[20];
char Spr_Name[20];
SL_Name[0]=0; Spr_Name[0]=0;
int handle;
char *lst[500];

SLIB_ITEM li[500];
SLIB_HDR  lh;

if((getfile("*.SL","Pick SLIB",SL_Name))==0)     {  return; }

if((handle=_open(SL_Name,O_RDWR))==-1)
{
MessageBox("Unable to open .SL file",1);
return;
}

 if((_read(handle, &lh, sizeof(lh)))==-1)
{
MessageBox("Unable to read .SL header",1);
}

 if((lh.SL[0]!='S') || (lh.SL[1]!='L'))
{
MessageBox("Incorrect library header",1);
}

_read(handle, li, sizeof(SLIB_ITEM)*500);

for(int k=0; k<500; k++)
 lst[k]=(char *) &li[k].FileName;

WINDOW w(-1, -1, 260, 160,"Browse SLIB", DLG_FRAME);
w.ShowWindow();
BUTTON del(w.x+20,w.y+135, 80, 20, "&Remove",kbEnter);
BUTTON cancel(w.x+160,w.y+135, 80, 20, "&Cancel",kbEsc);
del.ShowButton();
cancel.ShowButton();

w.RPrint(-1,25, "F1 for current position.",LIGHTBLUE);
//int gg;
LIST list(w.x+8, w.y+60, 6, 500, 30, lst);

EVENT event;

Update:

list.Show();

go:

event=_GetEvent();

list.ProcessEvent(&event);

if(event.keyboard==kbF1)
{
MessageBoxf(0,"Current position=%d",list.curr);
goto go;
}

if(cancel.ProcessEvent(&event)==PRESSED) goto ex;

if(del.ProcessEvent(&event)==PRESSED)
{
Spr_Name[0]=0;

if((getfile(SPR_Ext,"Pick Sprite",Spr_Name))==0) goto ex;

strupr(Spr_Name);

list.list[list.curr][0]=0;

strcat(list.list[list.curr],Spr_Name);

list.Update();
goto go;
}

if(event.keyboard==kbDel)
{
Spr_Name[0]=0;

strcat(Spr_Name,"__NONAME.SPR");

list.list[list.curr][0]=0;

strcat(list.list[list.curr],Spr_Name);

list.Update();
goto go;

}

goto go;

ex:

lseek(handle,0,SEEK_SET);

if(_write(handle, &lh,sizeof(lh))==-1) goto err;

if(_write(handle, li,sizeof(SLIB_ITEM)*500)==-1)
{
err:
MessageBoxf(1,"|~Unable to write relocation table in|~'%s'",SL_Name);
}

close(handle);

w.DeleteWindow();

}

void MP_CreatMap(void)
{

}


void MP_TileTest(void)
{
if(MapFlag==-1) { MessageBox("No Map loaded!",1); return; }

WINDOW s(-1,-1,300,160,"Tile Test",DLG_FRAME);
s.ShowWindow();

BUTTON ok(s.x+210,s.y+130,80,20,"&OK",kbEnter);
ok.Show();

VSCROLL sc(s.x+260,s.y+20,95,500);
sc.absposition=CurEditTile;

sc.Show();

EVENT event;

Update:

mouse_hide();

VideoSetFillStyle(0,15);
VideoBar(s.x+10,s.y+20,s.x+200,s.y+150);

int TileMem=WorkTile[CurEditTile].dx*WorkTile[CurEditTile].dy;

s.RPrint(10,120,"Tile: %d; Mem: %dbytes;",LIGHTBLUE,CurEditTile,TileMem);
s.RPrint(10,130,"DX:   %d; DY:  %d;",LIGHTBLUE,WorkTile[CurEditTile].dx,WorkTile[CurEditTile].dy);

if(TileFlags[CurEditTile]!=0)
{
DrawTileAt(s.x+10,s.y+20,&WorkTile[CurEditTile]);
}


mouse_show();

go:

event=_GetEvent();


if(sc.ProcessEvent(event)!=0)
{
CurEditTile=sc.absposition;
goto Update;
}

if( (ok.ProcessEvent(&event))==PRESSED) goto ex;

goto go;

ex:

s.DeleteWindow();
ShowStatus();
ShowEditTile();

}


void MP_GetMapInfo(void)
{

if(MapFlag==-1) MessageBox("No Map loaded!",1);
else MessageBoxf(0,"|-- MapInfo --|~Map: %s|~SizeX: %d (in screens)|~SizeY: %d (in screens)|~SprLib: %s",CurMap.Descr,CurMap.SizeX,CurMap.SizeY,CurMap.SprLib);

}

void MP_SaveMap(void)
{
int h;

h=_creat(MapName,FA_ARCH);

if(h==-1)
{
MessageBox("Unable to creat Map!",1);
puts(MapName);
return;
}

//if(_write(h,&CurMap,sizeof(MAP_HDR))==-1)
if(1!=1)
{
WriteErr:

MessageBoxf(1,"DOS Error: %s",sys_errlist[errno]);
close(h);
return;
}

if(_write(h,DuneMap,98*98)==-1) goto WriteErr;

close(h);
}

void MP_TestFrameSpeed(void)
{
}



void MP_ViewMap(void)
{

   RedrawCurPlane();
   ShowVirtMap();

go:

switch(getkey())
{

case LEFT:

	   if((ShowMapX-StepX)>=0)
	    {
	    ShowMapX-=StepX;
	    RedrawCurPlane();
	    ShowVirtMap();
	    }
	    goto go;

case RIGHT:

	   if((ShowMapX+StepX)<=CurMap.SizeX*MAP_DX)
	    {
	    ShowMapX+=StepX;
	    RedrawCurPlane();
	    ShowVirtMap();
	    }
	    goto go;

case UP:

	   if((ShowMapY-StepY)>=0)
	    {
	    ShowMapY-=StepY;
	    RedrawCurPlane();
	    ShowVirtMap();
	    }
	    goto go;

case DOWN:

	   if((ShowMapY+StepY)<=CurMap.SizeY*MAP_DY)
	    {
	    ShowMapY+=StepY;
	    RedrawCurPlane();
	    ShowVirtMap();
	    }
	    goto go;

case kbEsc: break;

default: goto go;
};

}



int U_GetTwoValues(char *head,char *m1,char *m2,int min,int max,int *v1,int *v2)
{
WINDOW s(-1,-1,300,140,head,DLG_FRAME);
s.ShowWindow();
min+=0;
BUTTON ok(s.x+10,s.y+110,80,20,"&Use this",kbEnter);
BUTTON cancel(s.x+210,s.y+110,80,20,"&Cancel",kbEsc);

EVENT e;

char s1[20];
char s2[20];
s1[0]=0; s2[0]=0;

itoa(*v1,s1,10);
itoa(*v2,s2,10);

InputLine il(s.x+120,s.y+25,s1,12, kbAlt1);
InputLine il2(s.x+120,s.y+25+20,s2,12, kbAlt2);

ok.Show();
cancel.Show();

il.Show();
il2.Show();
s.SetTextColor(0);
s.UString(10,25+5-13,m1);
s.UString(10,25+5-13+20,m2);

go2:

e=_GetEvent();

il.ProcessEvent(&e);
il2.ProcessEvent(&e);

if((cancel.ProcessEvent(&e))==PRESSED) {
s.DeleteWindow();
return -1;
}


if((ok.ProcessEvent(&e))==PRESSED) {

*v1=atoi(s1);
*v2=atoi(s2);

s.DeleteWindow();
return 0;
}

max+=0;

goto go2;

}


void MP_Work(void)
{
for(int i=0; i<98; i++)
for(int j=0; j<98; j++)
   DuneMap[j+i*98]=40;

	     LoadPalette("dune3.pal");
             MP_LoadSprites();

   RedrawCurPlane();
   ShowVirtMap();
   ShowEditTile();
//	     MP_LoadMap();

EVENT e;
int comm;

go:

e.keyboard=0;
e.mouse.buttons=0;
comm=0;

e=_GetEvent();

if(e.keyboard!=0) { comm=e.keyboard; goto key; }

if(e.mouse.buttons & 1)
{

if( ((e.mouse.x>=MAP_X) && (e.mouse.x<=MAP_X+MAP_DX)) && ((e.mouse.y>=MAP_Y) && (e.mouse.y<=MAP_Y+MAP_DY)))
{
int mx,my;
mx=ShowMapX+e.mouse.x-MAP_X;
my=ShowMapY+e.mouse.y-MAP_Y;
int sx,sy,sdx,sdy,Spr;

if(MapFlag!=-1)
{

for(int i=MapItemsNumber-1; i>=0; i--)
{
//Spr=MapItems[i].Sprite;
Spr=-1;
if(Spr==-1)         continue;

sx=0; //MapItems[i].x;
sy=0; //MapItems[i].y;

int plane=0; //MapItems[i].Plane;
int place;

sdx=WorkTile[Spr].dx+sx;
sdy=WorkTile[Spr].dy+sy;

//if(plane!=CurPlane) continue;

if(((mx>=sx) && (mx<=sdx)) && ((my>=sy) && (my<=sdy)))
{

WINDOW s(-1,-1,300,140,"Sprite Control Panel",DLG_FRAME);

s.ShowWindow();

BUTTON ok(s.x+10,s.y+110,80,20,"&Use this",kbEnter);
BUTTON cancel(s.x+210,s.y+110,80,20,"&Delete",kbAltD);
BUTTON res(s.x+110,s.y+110,80,20,"&Res",kbAltR);

NUMBER pl(&plane,s.x+230,s.y+36,-1,254);
place=i;
NUMBER plc(&i,s.x+230,s.y+60,-1,MapItemsNumber);

s.SetTextColor(0);

s.RPrint(10,10, "Place: %d; X:Y:   %d:%d",LIGHTBLUE,i,sx,sy);
s.RPrint(10,20, "Tile : %d; DX:DY: %d:%d",LIGHTBLUE,Spr,sdx-sx,sdy-sy);
s.RPrint(170,30,   "Plane:",LIGHTBLUE);
s.RPrint(170,30+24,"Place:",LIGHTBLUE);
DrawTileAt(s.x+10,s.y+45,&WorkTile[Spr]);

pl.Show();
plc.Show();

ok.Show();
res.Show();
cancel.Show();

EVENT e;

go2:

e=_GetEvent();

pl.ProcessEvent(&e);
plc.ProcessEvent(&e);

if((res.ProcessEvent(&e))==PRESSED) {

int v1=0; //MapItems[i].Res1;
int v2=0;//MapItems[i].Res2;
char r1,r2;

int k=0;

k=U_GetTwoValues("Change Res's","Res&1:","Res&2:",0,255,&v1,&v2);

if(k!=-1)
{
r1=v1;
r2=v2;

//MapItems[i].Res1=r1;
//MapItems[i].Res2=r2;
}

goto go2;
}

if((cancel.ProcessEvent(&e))==PRESSED) {

     s.DeleteWindow();

//     DuneMap();


     RealRedrawCurPlane();
     ShowStatus();
     ShowEditTile();

goto Ex;
				       }

if((ok.ProcessEvent(&e))==PRESSED) {


//MapItems[i].Plane=plane;

if(place!=i)
{
//if(MapItems[i].Sprite!=-1)
//{ MessageBoxf(1,"Place %d, is already used!",i); goto go2; }

//MapItems[place].Sprite=-1;

/*MapItems[i].Sprite=Spr;
MapItems[i].Plane=MapItems[place].Plane;
MapItems[i].x=MapItems[place].x;
MapItems[i].y=MapItems[place].y;
*/
     s.DeleteWindow();
     RealRedrawCurPlane();
     ShowStatus();
     ShowEditTile();

goto Ex;
}

     s.DeleteWindow();
goto Ex;
				   }

goto go2;

Ex:

goto go3;
}

}

MessageBoxf(1,"No sprite at %d:%d;",mx,my);
go3:

}
else MessageBox("No Map loaded!",1);

}

goto go;
}


if(e.mouse.buttons & RIGHT_BUTTON)
{

if( ((e.mouse.x>=MAP_X) && (e.mouse.x<=MAP_X+MAP_DX)) && ((e.mouse.y>=MAP_Y) && (e.mouse.y<=MAP_Y+MAP_DY)))
{
int mx,my;
mx=ShowMapX+e.mouse.x-MAP_X;
my=ShowMapY+e.mouse.y-MAP_Y;
int sx,sy,sdx,sdy,Spr;

if(MapFlag!=-1)
{

for(int i=MapItemsNumber-1; i>=0; i--)
{
Spr=-1; //MapItems[i].Sprite;
if(Spr==-1)         continue;

//sx=MapItems[i].x;
//sy=MapItems[i].y;

//int plane=MapItems[i].Plane;
int place=0;

sdx=WorkTile[Spr].dx+sx;
sdy=WorkTile[Spr].dy+sy;

//if(plane!=CurPlane) continue;

if(((mx>=sx) && (mx<=sdx)) && ((my>=sy) && (my<=sdy)))
{

/*
MapItems[i].Sprite=-1;
MapItems[i].Plane=-1;
MapItems[i].x=-1;
MapItems[i].y=-1;
*/
  RealRedrawCurPlane();
  ShowStatus();
  ShowEditTile();

goto go33;
}
place+=0;

}

}

go33:

e=_GetEvent();

if(e.mouse.buttons & RIGHT_BUTTON) goto go33;

;
}
else MessageBox("No Map loaded!",1);

goto go;
}


key:

int sdx,sdy;

sdx=WorkTile[CurEditTile].dx;
sdy=WorkTile[CurEditTile].dy;

switch(comm)
{

case kbAltF: if(MapFlag!=-1) MP_TestFrameSpeed(); goto go;

case kbAltM: MP_CreatMap();     goto go;
case kbAltS: MP_CreatSprLib();  goto go;
case kbAltB: MP_BrowseSprLib(); goto go;

case kbF3:
case kbAltL:

	     MP_LoadMap();
	     if(MapFlag!=-1) {
	     ShowStatus();
	     RealRedrawCurPlane();
	     ShowEditTile();
	     }
	     goto go;

case kbAltT: if(MapFlag!=-1) MP_TileTest();     goto go;
case kbAltI: if(MapFlag!=-1) MP_GetMapInfo();   goto go;

case kbAltX:
case kbF10: break;

case kbAltU:  if(MapFlag!=-1)
	     {
	     int k=PlaceUniqueMapItem();
	     if(k==-1) MessageBox("No free spot in map array!",1);

else {
	     Items++;
	     ShowStatus();
	     RealRedrawCurPlane();
	     ShowEditTile();
	     MessageBoxf(0,"Placed an unique tile %d at %d",CurEditTile,k);
     }
	     }
	     goto go;


case kbAltY:  if(MapFlag!=-1)
	     {
	     int k=PlaceUniqueMapItem();
	     if(k==-1) MessageBox("No free spot in map array!",1);

else {
	     Items++;
	     ShowStatus();
	     RealRedrawCurPlane();
	     ShowEditTile();
     }
	     }
	     goto go;



case SPACE:
case ENTER:  if(MapFlag!=-1)
	     {
	     if(PlaceMapItem()==-1)
	     { MessageBox("No free spot in map array!",1); goto go; }

	     Items++;
//	     ShowStatus();
	     RealRedrawCurPlane();
	     ShowEditTile();
	     }
	     goto go;

case kbAltF5:  if(MapFlag!=-1)
	     {
	     CurPlane++;
	     ShowStatus();
	     RealRedrawCurPlane();
	     ShowEditTile();
	     }

	     goto go;

case kbAltF6:  if(MapFlag!=-1 && CurPlane>0)
	     {
	     CurPlane--;
	     ShowStatus();
	     RealRedrawCurPlane();
	     ShowEditTile();
	     }
	     goto go;

case kbF7: if(MapFlag!=-1) {
	  StepY+=2;
	  ShowStatus();   }

	  goto go;

case kbF8: if(MapFlag!=-1 && StepY>3) {
	  StepY-=2;
	  ShowStatus();   }

	  goto go;

case kbF5: if(MapFlag!=-1) {
	  StepX+=2;
	  ShowStatus();   }

	  goto go;

case kbF6: if(MapFlag!=-1 && StepX>3) {
	  StepX-=2;
	  ShowStatus();
	  }

	  goto go;

case kbF2: if(MapFlag!=-1) MP_SaveMap(); goto go;

case kbAltV:   if(MapFlag!=-1)
	     {
	     int xx=ETX-ShowMapX;
	     int yy=ETY-ShowMapY;

	     MP_ViewMap();
	     ETX=ShowMapX+xx;
	     ETY=ShowMapY+yy;
	     ShowStatus();
	     RedrawCurPlane();
	     ShowEditTile();

	     }
	     goto go;

ScrollLeft:
case kbCtrlLeft:

	   if((MapFlag!=-1) && ((ShowMapX)>=1))
	    {
	    ShowMapX--;
	    ShowStatus();
	    RedrawCurPlane();
	    goto Lft;
	    }
	    goto go;

ScrollRight:
case kbCtrlRight:

	   if(MapFlag!=-1 && ((ShowMapX<87)))
	    {
	    ShowMapX++;
	    ShowStatus();
	    RedrawCurPlane();
	    goto Rght;
	    }
	    goto go;

ScrollUp:
case kbCtrlPgUp:

	   if((MapFlag!=-1) && ((ShowMapY)>0))
	    {
	    ShowMapY--;
	    ShowStatus();
	    RedrawCurPlane();
	    goto Up;
	    }
	    goto go;

ScrollDown:
case kbCtrlPgDn:

	   if((MapFlag!=-1) && (ShowMapY<89))
	    {
	    ShowMapY++;
	    ShowStatus();
	    RedrawCurPlane();
	    goto Dn;
	    }
	    goto go;


Rght:
case RIGHT: if(MapFlag!=-1)
	    {
  if((ETX/16-ShowMapX)<11)
  {
	    ETX+=16;
	    ShowStatus();
	    ShowEditTile();
   }
   else goto ScrollRight;

	    }
	    goto go;

Lft:
case LEFT: if(MapFlag!=-1)
	    {
	    if((ETX/16-ShowMapX)>=1)
	    {
	    ETX-=16;
	    ShowStatus();
	    ShowEditTile();
	    }
	    else goto ScrollLeft;
	    }
	    goto go;

Up:
case UP: if(MapFlag!=-1)
	    {
	    if((ETY/16-ShowMapY)>0)
	    {
	    ETY-=16;
	    ShowStatus();
	    ShowEditTile();
	    }
	    else goto ScrollUp;
	    }
	    goto go;

Dn:
case DOWN:  if(MapFlag!=-1)
	    {
	    if((ETY/16+1-ShowMapY)<MAP_DY/16)
	    {
	    ETY+=16;
	    ShowStatus();
	    ShowEditTile();
	    }
	    else goto ScrollDown;
	    }
	    goto go;


case GREY_PLUS: if((CurEditTile<499) && (MapFlag!=-1))
		{
		CurEditTile++;
		ShowStatus();
		ShowEditTile();
		} goto go;

case GREY_MINUS:
	       if((CurEditTile>0) && (MapFlag!=-1))
		{
		CurEditTile--;
		ShowStatus();
		ShowEditTile();
		} goto go;

default: goto go;

};

sdx+=0;
}
