/*

  Memory Routines Version 1.0
  (C) Mythical Software Group

*/

#include "stdlib.h"
#include "stdio.h"
#include "conio.h"
#include "time.h"
#include "string.h"
#include "fcntl.h"
#include "dos.h"
#include "stdarg.h"
#include "ctype.h"
#include "process.h"
#include "dir.h"
#include "io.h"
#include "alloc.h"
#include "mem.h"

int HiMem;
int ems_init(void);
unsigned long XMM_Control=0;
int XMM_flag;
int MessageBox(char *,int i=0);

void mem_init(void)
{
// XMS test:

HiMem=XMM_Installed();

}


unsigned XMM_Installed(void)
{

asm {
	mov ax,4300h
	int 2fh
	cmp al,80h
	jne No_HiMem

	mov ax,4310h
	int 2fh
	mov word ptr [XMM_Control],bx
	mov word ptr [XMM_Control+2],es
	jmp Installed
    };

No_HiMem:  return 0;

Installed: return 1;

}


char *XMM_Get_Error(int err)
{

switch(err) {

case 0x0:  return ("XMS: No error");
case 0x80: return ("XMS: Function not yet realised");
case 0x81: return ("XMS: VDISK.SYS found--XMS does't works");
case 0x82: return ("XMS: Error with line A20");
case 0x8e: return ("XMS: General error");
case 0x8f: return ("XMS: Fatal error");
case 0x90: return ("XMS: HMA does't exists");
case 0x91: return ("XMS: HMA already used");
case 0x92: return ("XMS: Register DX less parameter /HMAMIN");
case 0x93: return ("XMS: HMA doesn't not allocated to program");
case 0x94: return ("XMS: Line A20 unlocked yet");
case 0xa0: return ("XMS: All memory already allocated");
case 0xa1: return ("XMS: No more free EMB indexs");
case 0xa3: return ("XMS: Wrong 'SourceHandle'");
case 0xa4: return ("XMS: Wrong 'SourceOffset'");
case 0xa5: return ("XMS: Wrong 'DestHandle'");
case 0xa6: return ("XMS: Wrong 'DestOffset'");
case 0xa7: return ("XMS: Wrong 'Length'");
case 0xa8: return ("XMS: Not allowed data ovellaping");
case 0xa9: return ("XMS: Parity error");
case 0xaa: return ("XMS: EMB not locked");
case 0xab: return ("XMS: EMB locked");
case 0xac: return ("XMS: EMB lock counter overflowed");
case 0xad: return ("XMS: EMB locking failed");
case 0xb0: return ("XMS: UMB available with lesser size only");
case 0xb1: return ("XMS: No free UMB");
case 0xb2: return ("XMS: Wrong UMB segment");

default: return ("XMS: Unknown error!");

};

}

XMM_VER     XMM_Version(void)
{
int lw,hw,hma,vl,vh;

XMM_VER xmm_ver;
xmm_ver.lver=0;
xmm_ver.hver=0;
xmm_ver.mod=0;
xmm_ver.HMA=0;

if(HiMem==0) return xmm_ver; // No driver in memory

asm {

	xor ah,ah
	call [XMM_Control]
	mov byte ptr vl,al   // XMS Version;
	mov byte ptr vh,ah   // XMS Version;
	mov word ptr hw,bx   // Modification;
	mov word ptr hma,dx  // HMA info;

};

xmm_ver.lver=vl;
xmm_ver.hver=vh;
return xmm_ver;

}

int XMM_Get_Free_Mem(void)
{
int mem;

asm {
	mov ah,8
	mov bl,0
	call [XMM_Control]
	cmp bl,80h
	jae err
	mov word ptr mem,dx
};

  return mem;

err:

if((_BL==0) || (_BL==0xA0)) ;
else MessageBox(XMM_Get_Error(_BL),1);

return 0;
}