WinMessageBox(char *,char *,int=0);
int MessageBoxf(char *fmt, ... );
void UnderlineString(int, int, char *);

#define CW_HEADER 1L
#define DLG_FRAME 4L
#define ERR_FRAME 8L

class BUTTON {

char *label;
WORD x,y;
WORD length,heigth;
BYTE style;
int hotkey;
int status;

public:

// Constructors:

BUTTON(WORD ,WORD ,WORD , WORD , char *);
BUTTON(WORD ,WORD ,WORD , WORD , char *,int);

// Main Functions
void ShowButton(void);
void Show(void) { ShowButton(); }
int PressButton(void);
int ProcessEvent(struct MouseEvent);
int ProcessEvent(EVENT *);
void Enable(void)  { if(status!=0) {  status=0; Show(); }  }
void Disable(void) { if(status!=1) {  status=1; Show(); }  }

};


class WINDOW {

public:

char *header;
DWORD style;
WORD x,y,length,width;
void *save;
// For cache:
int flag;
char h;

BYTE background;
BYTE tcolor;

//      x  ,  y,  length, width, header
WINDOW(WORD,WORD, WORD,   WORD,  char *);
WINDOW(WORD,WORD, WORD,   WORD,  char *,DWORD);

int ShowWindow(void);    // Returns: 0 -- means OK, else -- error
void DeleteWindow(void);
void FreeMemory() { if(save!=0) { free(save); save=0; } };
void DrawFrame(void);
void DrawHeader(void);
void SetTextColor(int c) { tcolor=c;  }
void Print(int,int,char *,...);
void Print(int,int,char *,int,...); // Print with color
void UString(int,int,char *);
void Clear(int,int,int,int);
void RPrint(int,int,char *,int,...);
};


class VSCROLL {

public:

WORD x,y;
WORD heigth;

WORD absposition;  // In reality it's private variable;
WORD howmany;

//       x,   y,  len:
VSCROLL(WORD, WORD, WORD);
VSCROLL(WORD, WORD, WORD, WORD);
VSCROLL(void) { }
int ProcessEvent(EVENT event);
void Show(void);

void DeletePointer(void);
void DrawPointer(void);

};

class MENULIST {

public:

WORD x,y, len, hei, number;
WORD current;
char **list;
WORD realnum;
DWORD style;
int selitem;

WINDOW mywin;

MENULIST(WORD xx, WORD yy, WORD len, WORD num, char **massiv);
MENULIST(WORD xx, WORD yy, WORD len, WORD num, char **massiv,DWORD style);
int Show(void);
void Delete(void);
WORD GetChoice() { return current; }
int ProcessEvent(EVENT event);
int Check(WORD);
void Select(WORD);
void Unselect(WORD);

};


typedef struct tagMENU {

char *name;         // "&File"
char **menuitems;   // Open, Save, ...
int  *values;       // Values to be returned
int  key;           // Hot key to call it;
int  num;
int  maxlen;

} MENU;


class MENUBAR {

public:

WORD x,y;
WORD num;  // Options number

BYTE foregr,backgr;
MENU *barmenuitems;

//  Functions:
int ProcessEvent(EVENT *event);
void Show(void);
void Unselect(int);
void Select(int);
int  Work(int );
int  GetMouseChoice(EVENT *);
MENUBAR::MENUBAR(int _x,int _y,int _num,MENU *mnu);

};



class NUMBER {

public:
//      *V   x   y
int  min,max,delta;
int  *value;
WORD x,y;
NUMBER(int *,int,int,int,int);
NUMBER(int *,int,int,int,int,int);
void Show(void);
int  ProcessEvent(EVENT *);

};



class FRAME {

public:
WORD x,y,sx,sy;
char *label;
int style; // Left, Center OR Right


FRAME(int,int,int,int,char *);
void Show(void);

};


class LIST {

public:

int curr,x,y,list_num,show_num,len;
char **list;
VSCROLL scroller;
int realshow;

LIST(int,int,int,int,int,char **);
void Show();
int ProcessEvent(EVENT *);
void Select(int);
void Unselect(int);
void Up(void);
void Down(void);
void Update(void);

};


class InputLine {

public:

int x,y;
char *string;
int maxlen;
int hotkey;

InputLine();
InputLine(int,int,char *,int);
InputLine(int,int,char *,int,int);
void Show(void);
int ProcessEvent(EVENT *);

};

int GetStringXY(int,int,char *,int);

class ITEM {

public:

int x,y;
int state;  // 1--on, 0--off;
int hotkey;

ITEM(int xx,int  yy,int st,int hk) { x=xx; y=yy; state=st; hotkey=hk; }
int  ProcessEvent(EVENT *);
void Show(void);

};


class STATUSLINE {

public:

long x,y,len,max,curr;

void Show(void);
void Add(int);
STATUSLINE(int,int,int,int,int);

};


class ComboBox {

public:

int x,y;
char **list;
int current,length,number;


ComboBox(int xx,int yy,int curr,int len,char **lst,int num)
   { x=xx; y=yy; current=curr; list=lst; length=len; number=num; }
void Show(void);
int ProcessEvent(EVENT *);

};