#include "stdio.h"
#include "dos.h"
#include "ctype.h"
#include "string.h"
#include "STDLIB.H"

#define MAX_COMM 2

char *CommentarySymbol=";#";
int CurLine=0;

void PrepareString(char *);

int IsValue(char *s,long *vv)
{

if(stricmp(s,"True")==0) { *vv=1; return 0; }
if(stricmp(s,"False")==0) { *vv=0; return 0; }

if(stricmp(s,"Yes")==0) { *vv=1; return 0; }
if(stricmp(s,"No")==0) { *vv=0; return 0; }


long v=0;
char *endptr;

v=strtol(s,&endptr,0);

if((*endptr!=0))
{
v=strtol(s,&endptr,16); // Is Hex?

if((*endptr!=0))
{
*vv=0;
return -1;
}

}

*vv=v;

return 0;
}


int PrepareValue(char *v)
{
PrepareString(v);

if(v[0]=='=') v[0]=' ';

PrepareString(v);

if(v[0]==0)
{
printf("CFG Error: Nothing after '=' in line %d;\n",CurLine);
return -1;
}

return 0;
}

int ParseString(char *s,char *Comm,char *ValueStr)
{
Comm[0]=0;
ValueStr[0]=0;

int l=strlen(s);

if(l==0) return -1;

for(int off=0; off<l; off++)
  if((isalpha(s[off]))==0) break;

if(off==(l-1))
{
printf("CFG Error: Only one word in line %d;\n",CurLine);
return -1;
}

strncpy(Comm,s,off);
Comm[off]=0;
strcat(ValueStr,s+off);

return 0;
}

void DeleteAllComms(char *s)
{
int l=strlen(s);

if(l==0) return;

for(int kk=0; kk<l; kk++)
for(int i=0; i<MAX_COMM; i++)
 if(s[kk]==CommentarySymbol[i]) { s[kk]=0; return; }

}



int IsCommentary(char *s)
{
if(s[0]==0) return 0;

for(int i=0; i<MAX_COMM; i++)
 if(s[0]==CommentarySymbol[i]) return -1;

return 0;
}

void DeleteRight(char *s)
{
int i;

i=strlen(s);
i--;

while((isspace(s[i]))!=0) i--;

s[i+1]=0;
}



void PrepareString(char *s)
{
char str2[160];

str2[0]=0;

int i=0,i2=0,l=0;

l=strlen(s);

while((isspace(s[i]))!=0) i++;

strcpy(str2,s+i);

s[0]=0;
strcat(s,str2);
}


void CFG_Load(char *Name);
{
char buf[2048];
char str[160];
long v;

FILE *in;

if((in=fopen(Name,"r"))==NULL)
{
   fprintf(stderr, "Unable to open config file: %s;\n",Name);
   getch();
   return;
}

if(setvbuf(in, buf, _IOFBF, 2048)!=0)
{
puts("Failed to set up buffer for config file: %s;\n",Name);
getch();
}

char Comm[160];
char ValueStr[160];

while(!feof(in))
{
if(fgets(str,140,in)==0) break;

CurLine++;

PrepareString(str);

if(IsCommentary(str)==-1) continue;

DeleteAllComms(str);
DeleteRight(str);

if(ParseString(str,Comm,ValueStr)==-1) continue;

if(PrepareValue(ValueStr)==-1) continue;

v=0;

if(IsValue(ValueStr,&v)==-1)
{
printf("String -- %s -- for Comm: %s;\n",ValueStr,Comm);
}
else
{
printf("Value -- %ld -- for Comm: %s;\n",v,Comm);
}

}


fclose(in);
}
