#include "stdio.h"
#include "dos.h"
#include "conio.h"
#include "io.h"
#include "fcntl.h"
#include "string.h"
#include "stdlib.h"
#include "gamegrab.h"

//#include "sprite.h"

typedef struct _SPR_HDR_ {

char NK[2];      // Signature of Sprite Editor: 'NK';
char Version;
char VideoMode;
char Type;
int  SizeX;
int  SizeY;
int  DataLen;    // Lengh of base Data: mustn't be equal to zero;
int  MaskLen;    // Length of Mask: If zero -> no mask in sprite;

} SPR_HDR;


int VGA=0;

unsigned char getpixel(int,int);

#define INTR 0X09
int flag=0;         // 0--means not active

int  BPL; // Bytes Per Line
int  CurrScroll;
void ScrollDown(void);
void ScrollUp(void);
void MakeOffset(unsigned);
void interrupt (*oldhandler)(...);
int  GetPage(int);
void maingrab(void);
void hline(int,int,int,int );
void vline(int,int,int,int);
void SetVisualPage(char);

void MakeBPL(void);
unsigned char far string[1000]={ 0 };
int number=0;     // number of saved files
int VGAnumber=0;
int EGAnumber=0;
int PALnumber;
int BytesPerPage;

SPR_HDR icon;

char curmode=3;
char curpage=0;

char QuitFlag=0;

int key;
int tmp1,tmp2;

void ReadPalReg(char reg)
{
char r,g,b;

asm {

mov ax,1015h
mov bx,0
mov bl,reg
int 10h
mov r,dh
mov g,ch
mov b,cl

};

string[r*3]=r;
string[r*3+1]=g;
string[r*3+2]=b;

}

void GetPalette(void)
{
for(int i=0; i<256; i++) ReadPalReg(i);
}



char getvmode(void)
{
char mode;

asm mov ah,0fh;
asm int 10h;
asm mov curpage,bh;
mode=_AL;

if(mode==0x13) VGA=1;
else           VGA=0;

return mode;

}


int getkey(void)
{

asm xor ax,ax;
asm int 16h;
return _AX;

}


   void interrupt handler(...)
{


if(flag!=0) goto quit;

//  Cast Alt-K to call

asm {

 push ax
 in al,60h
 cmp al,37
 jz key
 cmp al,76
 pop ax
 jz our_prog
 jmp quit

};

key:

asm {
 pop ax
 push ax
 push es
 xor ax,ax
 mov es,ax
 mov al,es:[417h]
 test al,8
 pop es
 pop ax
 jnz our_prog
 jmp quit

};


our_prog:

asm {

 push ax
 in al,61h
 mov ah,al
 or al,80h
 out 61h,al
 xchg al,ah
 out 61h,al
 mov al,20h
 out 20h,al
 pop ax

};


asm {

push ax
push bx
push cx
push dx

};

asm mov ah,0fh;
asm int 10h;
asm mov curpage,bh;
asm mov curmode,al;

asm {
 pop dx
 pop cx
 pop bx
 pop ax
 sti

};

flag=1;

curmode=getvmode();

MakeBPL();

switch(curmode) {

case 0x0d:
case 0x0e:
case 0x10:
case 0x11:
case 0x13:

maingrab();

if(QuitFlag!=0) {

QuitFlag=0;

asm {

mov ax,4cffh
int 21h

};

}


break;

default:

sound(2000);
delay(200);
nosound();

};


flag=0;
goto full_quit;


quit:
oldhandler();

full_quit:
;

}





  void main(void)
{


 puts("Game Explorer & GRaBer Version 4.3 BY Alex Chudnovsky");
 puts("Copyright (C) Mythical Sofware Group 1994/95");
 puts("");
 puts(" Keys in work mode:");
 puts("Arrows       -> move rectangle;");
 puts("ESC or SPACE -> leave work mode;");
 puts("ENTER        -> switch between two remove modes;");
 puts("F2           -> save image located in the rectangle;");
 puts("F3           -> save EGA 320x200,16 colors image visible on screen;");
 puts("Grey Plus    -> increase rectangle step;");
 puts("Grey Minus   -> decrease rectangle step;");
 puts("'0'..'7'     -> set new work video page;");
 puts("P & '0'..'7' -> make new visual page;");
 puts("PageUp       -> hardware scrolling up;");
 puts("PageDown     -> hardware scrolling down;");
 puts("DIV & MUL    -> changing of BPL (Bytes Per Line) on screen;");
 puts("R            -> restore default BPL;");
 puts("S            -> show mouse pointer (if any);");
 puts("H            -> hide mouse pointer (if any);");
 puts("V            -> save VGA 256 color picture in file;");
 puts("E            -> equialize rectangle sizes to 16x16;");
 puts("I            -> Initialize current video mode (helps to detect some things);");
 puts("M            -> Print current mode hex. number;");
 puts("A            -> Save VGA pAlette in PALxxx.PAL");

 puts("\n\rCast Alt-K or '5' on numeric keypad to enter work mode...");

oldhandler=getvect(INTR);
setvect(INTR, handler);

keep(0,18000/16);

}


void putpixel(int x,int y,char col)
{
char color;

if(curmode==0x13)
{
color=getpixel(x,y);

color=~color;

_AH=0x0c;
_BH=curpage;
_CX=x;
_DX=y;
_AL=color;
asm int 10h;
}
else
{

_AH=0x0c;
_BH=curpage;
_CX=x;
_DX=y;
_AL=15+0x80;
asm int 10h;

}

}


void box(int x1,int y1,int x2,int y2)
{
int x,y;

hline(x1, y1, x2, y1);
hline(x1, y2, x2, y2);

vline(x1, y1, x1, y2);
vline(x2, y1, x2, y2);

}



 void hline(int x1,int y1,int x2,int y2)
{
int x;

 for(x=x1; x<x2; x++)
 putpixel(x,y1,15);

}

 void vline(int x1,int y1,int x2,int y2)
{
int y;


 for(y=y1;y<y2;y++)
 putpixel(x1,y,15);

}


unsigned char getpixel(int x,int y)
{

_AH=0x0d;
_BH=curpage;
_CX=x;
_DX=y;
asm int 10h;

return _AL;

}

  void maingrab(void)
{
static int x,y;
static int sizex=10,sizey=10;
int fl=0;   // 0 -- no box on screen, 1 -- yes
static int step=5;
int handle;
char res;

static char filename[10];
int ax,ay,i;


box(x,y,x+sizex,y+sizey);

begin:
key=getkey();

switch(key) {

case UP:    box(x,y,x+sizex,y+sizey);
	    if(fl==0) {
	     y-=step;
	     box(x,y,x+sizex,y+sizey);
		      }
	    else {
	     sizey-=step;
	     box(x,y,x+sizex,y+sizey);
		 }
	      break;


case DOWN:
box(x,y,x+sizex,y+sizey);
	    if(fl==0) {
	     y+=step;
	     box(x,y,x+sizex,y+sizey);
		      }
	    else {
	     sizey+=step;
	     box(x,y,x+sizex,y+sizey);
		 }
		 break;

case DIV: if(BPL>1) BPL--; break;

case MUL: BPL++; break;

case RIGHT:
	box(x,y,x+sizex,y+sizey);
	    if(fl==0) {
	     x+=step;
	     box(x,y,x+sizex,y+sizey);
		      }
	    else {
	     sizex+=step;
	     box(x,y,x+sizex,y+sizey);
		 }
	break;

case GREY_PLUS: step++; break;

case GREY_MINUS: if(step>1) step--; break;

case LEFT:

box(x,y,x+sizex,y+sizey);
	    if(fl==0) {
	     x-=step;
	     box(x,y,x+sizex,y+sizey);
		      }
	    else {
	     sizex-=step;
	     box(x,y,x+sizex,y+sizey);
		 }

	       break;

case ENTER: if(fl==0) fl=1;
	    else      fl=0;

	    break;

case F3:

if(curmode==0x0D)
{

box(x,y,x+sizex,y+sizey);

filename[0]=0;
itoa(EGAnumber,filename,10);
strcat(filename,".EGA");

handle=_creat(filename,FA_ARCH);

for(ay=0; ay<200; ay++)
{

  for(i=0,ax=0; ax<320; i++,ax++)
  string[i]=getpixel(ax,ay);

res=_write(handle,&string,320);

if(res==-1)
{
sound(10000);
delay(300);
nosound();
}

}

close(handle);

filename[0]=0;
strcat(filename,"EGA");
itoa(EGAnumber,filename,10);
strcat(filename,".PAL");

handle=_creat(filename,FA_ARCH);
if(handle==-1) goto EGAFileErr;

GetPalette();
res=_write(handle,&string,768);

close(handle);

EGAFileErr:

if(res==-1)
{
sound(10000);
delay(300);
nosound();
}

box(x,y,x+sizex,y+sizey);

EGAnumber++;
sound(1000);
delay(30);
nosound();
}
break;

case F2:

icon.NK[0]='N';
icon.NK[1]='K';
icon.Version=10;
icon.VideoMode=curmode;
icon.Type=80;      // GRB file type...
icon.SizeY=sizey;  //sizey;
icon.SizeX=sizex;  //sizex;
icon.DataLen=sizey*sizex;
icon.MaskLen=0;

box(x,y,x+sizex,y+sizey);

filename[0]=0;
itoa(number,filename,10);
strcat(filename,".SPR");

number++;
handle=_creat(filename,FA_ARCH);

res=_write(handle, &icon, sizeof(icon));

if(res==-1)
{

sound(10000);
delay(300);
nosound();

}

for(ay=y+1; ay<y+sizey+1; ay++)
{

  for(i=0,ax=x+1; ax<x+sizex+1; i++,ax++)
  string[i]=getpixel(ax,ay);

res=_write(handle,&string,sizex);

if(res==-1)
{

sound(10000);
delay(300);
nosound();

}

}

close(handle);

box(x,y,x+sizex,y+sizey);

sound(1000);
delay(30);
nosound();

break;

case SPACE:
case ESC:  box(x,y,x+sizex,y+sizey); goto quit;   // exit

case PGUP:   ScrollUp();   break;

case PGDOWN: ScrollDown(); break;

default:

key=(key<<8)>>8;

if((key=='s') || (key=='S'))
{

asm push ax;
asm mov ax,0001h;
asm int 33h;
asm pop ax
}

if((key=='a') || (key=='A'))
{
filename[0]=0;
itoa(PALnumber,filename,10);
strcat(filename,"PAL.PAL");

handle=_creat(filename,FA_ARCH);
if(handle==-1) { puts("PAL creat error!"); goto PALFileErr; }

GetPalette();
_write(handle,string,768);

PALnumber++;
PALFileErr:
close(handle);
}

if((key=='v') || (key=='V'))
{

if(curmode==0x13)
{

box(x,y,x+sizex,y+sizey);

filename[0]=0;
itoa(VGAnumber,filename,10);
strcat(filename,".VGA");

handle=_creat(filename,FA_ARCH);

for(ay=0; ay<200; ay++)
{

  for(i=0,ax=0; ax<320; i++,ax++)
  string[i]=getpixel(ax,ay);

res=_write(handle,&string,320);

if(res==-1)
{

sound(10000);
delay(300);
nosound();

}

}

close(handle);

filename[0]=0;
itoa(VGAnumber,filename,10);
strcat(filename,".PAL");

handle=_creat(filename,FA_ARCH);
if(handle==-1) goto FileErr;

GetPalette();
res=_write(handle,&string,768);

close(handle);

FileErr:

if(res==-1)
{
sound(10000);
delay(300);
nosound();
}

box(x,y,x+sizex,y+sizey);

VGAnumber++;
sound(1000);
delay(30);
nosound();

}

} // End


if((key=='h') || (key=='H'))
{

asm push ax;
asm mov ax,0002h;
asm int 33h;
asm pop ax

}


if((key>='0') || (key<='7'))
{
box(x,y,x+sizex,y+sizey);
curpage=key-'0';
box(x,y,x+sizex,y+sizey);
}

if((key=='r') || (key=='R')) MakeBPL();

if((key=='i') || (key=='I')) 
{  
box(x,y,x+sizex,y+sizey);
asm mov ah,0;
asm mov al,curmode;
asm int 10h;
box(x,y,x+sizex,y+sizey);
}

if((key=='m') || (key=='M'))
{  
printf("VideoMode: %d;\n\r",curmode);
}


if(key=='8')
{  
box(x,y,x+sizex,y+sizey);
sizex=8;
sizey=8;
box(x,y,x+sizex,y+sizey);
}


if((key=='e') || (key=='E'))
{

if((sizex!=16) || (sizey!=16))
{
box(x,y,x+sizex,y+sizey);
sizex=16;
sizey=16;
box(x,y,x+sizex,y+sizey);
}

}


if((key=='p') || (key=='P'))
{

key=getkey();
key=(key<<8)>>8;

if((key>='0') || (key<='7'))
{

SetVisualPage(key-'0');

}

}

break;

};

goto begin;

quit:

;
}

void SetVisualPage(char p)
{

asm {

mov ah,5
mov al,p
int 10h

};

}


void ScrollDown(void)
{

CurrScroll++;

MakeOffset(CurrScroll*BPL);

}


void ScrollUp(void)
{

if(CurrScroll==0) return;
CurrScroll--;

MakeOffset(CurrScroll*BPL);

}


void MakeOffset(unsigned off)
{

asm {

mov bx,off
mov dx,3d4h
mov al,12
out dx,al
inc dx
mov al,bh
out dx,al
dec dx
mov al,13
out dx,al
inc dx
mov al,bl
out dx,al

};

}


void MakeBPL(void)
{

switch(curmode) {

case 0x0d: BPL=40;  break;

case 0x0e:
case 0x10:
case 0x11: BPL=80;  break;

case 0x13: BPL=320; break;

default: BPL=40;

};

}
