#include "graphics.h"
#include "stdlib.h"
#include "stdio.h"
#include "conio.h"
#include "time.h"
#include "string.h"
#include "fcntl.h"
#include "dos.h"
#include "stdarg.h"
#include "ctype.h"
#include "process.h"
#include "dir.h"
#include "io.h"
#include "pcxlib.h"
#include "alloc.h"
#include "bwg.h"
#include "tkeys.h"
#include "gamekit.h"
#include "mem.h"
#include "objects.h"
#include "objects2.h"
#include "video.h"
#include "sprite.h"
#include "library.h"
#include "backgrnd.h"

void DrawRectVirtualPage(int VirtX,int VirtY,char *Rect,char RectSizeX,\
char RectSizeY,char RectX,char RectY,char RectDX,char RectDY);
void VirtualClear(int,int,int,int);
void DrawTileAt(int x,int y,TILE *tile);
void PutVirtualTileAt(int x,int y,TILE *tile);
int MP_LoadMap(char *MapName);

typedef struct _MAP_HDR_ {

char SL[2];
char Descr[30];
char SprLib[13];
int  Number;
int SizeX;
int SizeY;

} MAP_HDR;

typedef struct _MAP_ITEM_ {

int x,y;
int Sprite;
char Res1,Res2;  // Reserved 2 bytes;
char Plane;      // Output Plane;

} MAP_ITEM;

typedef struct _SLIB_HDR_ {

char SL[2];
char Descr[20];
int  Number; // Max number;

} SLIB_HDR;


typedef struct _SLIB_ITEM_ {

char FileName[13];

} SLIB_ITEM;

int       MapFlag=-1;

MAP_HDR   CurMap;

TILE      WorkTile[500];
MAP_ITEM  MapItems[1000]={ -1 };
char      TileFlags[500]={  0 };

//char MapName[20]={ 0 };

int CurEditTile,ETX,ETY;

int   ShowMapX=0,ShowMapY=0;
int   StepX=16,StepY=16;
int   Items;

void  CloseSpriteManager(void);
int   InitSpriteManager(void);

void  MP_Work(void);
void Work(void);

int MAP_X=60;
int MAP_Y=32;
int MAP_DX=160;
int MAP_DY=128;

/*
#define MAP_X  60
#define MAP_Y  16
#define MAP_DX 200
#define MAP_DY 128
*/
int CurPlane=0;

char *MapN;

void main(int argc,char **argv)
{

if(argc==1)
{
puts("MAPPER Version 1.01 BY Alex Chudnovsky");
puts("Copyright (C) Mythical Software Group 1994/95");
puts(" Usage: MAPPER Map_Name.MAP [-options]");

puts("");

  puts("-S -- Set new screen sizes;");
  puts("-M -- Set new scrolling steps;");

puts("");

puts(" Keys inside:");
puts("Arrows -- Scroll Map;");
puts("Alt-F  -- Count frame speed;");
puts("");
puts("");
puts("");
puts("Alt-X  -- Quit;");
return;
}

if(argv[1][0]=='-')
{
puts("Error: You must give MapName first!");
return;
}

if(argc>2) {

for(int i=2; i<argc; i++)
{

strupr(argv[i]);

if(strcmp(argv[i],"-M")==0)
{
printf("Enter new value for StepX (0-100): ");
scanf("%d",&StepX);
printf("Enter new value for StepY (0-100): ");
scanf("%d",&StepY);

continue;
}

if(strcmp(argv[i],"-S")==0)
{
printf("Current screen settings: StartX: %d, StartY: %d, Length: %d, Width: %d;\n\r",MAP_X,MAP_Y,MAP_DX,MAP_DY);
printf("Enter new value for  StartX (0-254): ");
scanf("%d",&MAP_X);
printf("Enter new value for  StartY (0-198): ");
scanf("%d",&MAP_Y);
printf("Enter new value for Length  (0-254): ");
scanf("%d",&MAP_DX);
printf("Enter new value for  Width  (0-198): ");
scanf("%d",&MAP_DY);

if(MAP_X==-1) MAP_X=160-MAP_DX/2;
if(MAP_Y==-1) MAP_Y=100-MAP_DY/2;

printf("Now screen settings are: StartX: %d, StartY: %d, Length: %d, Width: %d;\n\r",MAP_X,MAP_Y,MAP_DX,MAP_DY);
getch();
continue;
}

printf("Unknown command parameter: %s;\n\r",argv[i]);

}

}


MapN=argv[1];

Work();

}


int IsInside(int x,int y,int x1,int y1,int x2,int y2)
{
if((x>=x1 && x<=x2) && (y>=y1 && y<=y2)) return 0;
else                                    return -1;
}

int IsRectIn(int x1,int y1,int x2,int y2,int Ex1,int Ey1,int Ex2,int Ey2)
{

if(IsInside(x1,y1,Ex1,Ey1,Ex2,Ey2)==-1) return -1;
if(IsInside(x1,y2,Ex1,Ey1,Ex2,Ey2)==-1) return -1;
if(IsInside(x2,y1,Ex1,Ey1,Ex2,Ey2)==-1) return -1;
if(IsInside(x2,y2,Ex1,Ey1,Ex2,Ey2)==-1) return -1;

return 0;
}

int IsOverl(int x1,int y1,int x2,int y2,int Ex1,int Ey1,int Ex2,int Ey2)
{

if(IsInside(x1,y1,Ex1,Ey1,Ex2,Ey2)==0) return 0;
if(IsInside(x1,y2,Ex1,Ey1,Ex2,Ey2)==0) return 0;
if(IsInside(x2,y1,Ex1,Ey1,Ex2,Ey2)==0) return 0;
if(IsInside(x2,y2,Ex1,Ey1,Ex2,Ey2)==0) return 0;

return -1;
}


void RedrawPlane(int pl)
{
int x1,y1,x2,y2;

int Ex1=MAP_X+ShowMapX;
int Ex2=Ex1+MAP_DX;
int Ey1=MAP_Y+ShowMapY;
int Ey2=Ey1+MAP_DY;

for(int i=0; i<300; i++)
//for(int i=0; i<1000; i++)
{
if(MapItems[i].Sprite==-1) continue;
if(MapItems[i].Plane!=pl)  continue;

x1=MapItems[i].x+Ex1-ShowMapX;
y1=MapItems[i].y+Ey1-ShowMapY;

x2=x1+WorkTile[MapItems[i].Sprite].dx;
y2=y1+WorkTile[MapItems[i].Sprite].dy;

if(IsOverl(x1,y1,x2,y2,Ex1,Ey1,Ex2,Ey2)==0)
{
DrawVirtualTileAt(x1-ShowMapX,y1-ShowMapY,&WorkTile[MapItems[i].Sprite]);
continue;
}

continue;

if(IsRectIn(x1,y1,x2,y2,Ex1,Ey1,Ex2,Ey2)==0)
{
DrawVirtualTileAt(x1-ShowMapX,y1-ShowMapY,&WorkTile[MapItems[i].Sprite]);
//PutVirtualTileAt(x1-ShowMapX,y1-ShowMapY,&WorkTile[MapItems[i].Sprite]);
continue;
}

}

}

void RedrawCurPlane(void)
{
VirtualClear(MAP_X,MAP_Y,MAP_X+MAP_DX,MAP_Y+MAP_DY);
RedrawPlane(CurPlane);
}

void ShowVirtMap(void)
{
VirtualPage2Screen(MAP_X,MAP_Y,MAP_DX,MAP_DY);
}

int GetItems(void)
{
int v=0;
for(int i=0; i<1000; i++)
{
if(MapItems[i].Sprite==-1) continue;
v++;
}
return v;
}

void ShowEditTile(void)
{
ShowVirtMap();

if(TileFlags[CurEditTile]!=0)
{
DrawTileAt(MAP_X+ETX-ShowMapX,MAP_Y+ETY-ShowMapY,&WorkTile[CurEditTile]);
}

}

void FreeTiles(void)
{
for(int i=0; i<500; i++)
 ReleaseTile(&WorkTile[i]);
}
void Map(void);

void *mem;

void Work(void)
{

if(InitSpriteManager()==-1)
{
No_Mem:
puts("Out of memory!");
return;
}

mem=malloc(64000);
if(mem==0) goto No_Mem;

VirtualClear(MAP_X,MAP_Y,MAP_X+MAP_DX,MAP_Y+MAP_DY);

if(MP_LoadMap(MapN)==-1) return;

asm mov ax,13h;
asm int 10h;

Map();

asm mov ax,3;
asm int 10h;

//CloseSpriteManager();
}


int MP_LoadMap(char *MapName)
{
int h,h2;

if((h=_open(MapName,O_RDWR))==-1)
{
printf("Unable to open Map: '%s'",MapName);
return -1;
}

SLIB_HDR  sl;
SLIB_ITEM item;

if(MapFlag!=-1) FreeTiles();

_read(h,&CurMap,sizeof(MAP_HDR));

if(CurMap.SL[0]!='M' || CurMap.SL[1]!='P')
{
printf("LoadMap: File -- '%s' -- isn't a valid Map!",MapName);
return -1;
}

if((h2=_open(CurMap.SprLib,O_RDWR))==-1)
{
printf("Unable to open Map SprLib:|'%s'",CurMap.SprLib);
close(h);
return -1;
}


_read(h,&MapItems,1000*sizeof(MAP_ITEM));

_read(h2,&sl,sizeof(SLIB_HDR));

int Err=0;
int LoadedTiles=0;

int Mem1,Mem2;

Mem1=getfreemem();

for(int j=0; j<500; j++)
{
_read(h2,&item,sizeof(SLIB_ITEM));

strupr(item.FileName);

if(strcmp(item.FileName,"__NONAME.SPR")==0)
{
TileFlags[j]=0;
continue;
}

if(LoadTile(item.FileName,&WorkTile[j])==-1)
{
//printf("Unable to load tile:|'%s'",item.FileName);
Err=-1;
continue;
}

TileFlags[j]=100;
LoadedTiles++;
}

Mem2=getfreemem();

printf("\
Tiles Loaded: %d;\n\r\
Used mem    : %dk;",LoadedTiles,Mem1-Mem2);

close(h);
Items=GetItems();
ShowMapX=0;
ShowMapY=0;

if(Err==-1) return -1;
else        return 0;
}


void MP_TestFrameSpeed(void)
{
long *Timer=(long *) MK_FP(0,0x46c);
long T1,T2;

int frames=120;

T1=*Timer;

for(int i=0; i<frames; i++)
{
  RedrawCurPlane();
  ShowVirtMap();
}

T2=*Timer;
int time=T2-T1;
int t1=frames*100/time;
int t2=t1%100;
t1=t1/100;
if(t2<9) t2=10;

printf("\n\rFrame Speed Test:\n\r Frames done    : %d,\n\r Time           : %d ticks,\n\r Frames per tick: %d.%d\n\r (Redraw was for curr. plane)",frames,time,t1,t2);

}

int getkey(void)
{
asm xor ax,ax;
asm int 16h;

return _AX;
}


void Map(void)
{
VirtualClear(MAP_X,MAP_Y,MAP_X+MAP_DX,MAP_Y+MAP_DY);
   RedrawCurPlane();
   ShowVirtMap();

go:

switch(getkey())
{

case LEFT:

	   if((ShowMapX-StepX)>=0)
	    {
	    ShowMapX-=StepX;
	    RedrawCurPlane();
	    ShowVirtMap();
	    }
	    goto go;

case RIGHT:

	   if((ShowMapX+StepX)<=CurMap.SizeX*MAP_DX)
	    {
	    ShowMapX+=StepX;
	    RedrawCurPlane();
	    ShowVirtMap();
	    }
	    goto go;

case UP:

	   if((ShowMapY-StepY)>=0)
	    {
	    ShowMapY-=StepY;
	    RedrawCurPlane();
	    ShowVirtMap();
	    }
	    goto go;

case DOWN:

	   if((ShowMapY+StepY)<=CurMap.SizeY*MAP_DY)
	    {
	    ShowMapY+=StepY;
	    RedrawCurPlane();
	    ShowVirtMap();
	    }
	    goto go;

case kbF1: ShowEditTile(); goto go;

case kbF2: CurEditTile++; goto go;

case kbF3: if(CurEditTile>0) CurEditTile--; goto go;

case kbAltF: MP_TestFrameSpeed(); goto go;

case kbAltX:
case kbEsc: break;

default: goto go;
};

}



int getfreemem(void)
{
void *k[640];
int kb=0;

while((k[kb]=malloc(1024))!=0) kb++;

for(int i=0;i<kb;i++) free(k[i]);

return kb;
}

