#include "string.h"
#include "sprite.h"
#include "io.h"
#include "fcntl.h"
#include "stdio.h"
#include "stdlib.h"
#include "dos.h"
#include "conio.h"

typedef struct _SLIB_HDR_ {
char SL[2];
char Descr[20];
int  Number; // Max number;
} SLIB_HDR;


typedef struct _SLIB_ITEM_ {
char FileName[13];
} SLIB_ITEM;

typedef struct _SLDLIB_HDR_ {
char SL[2];      // SD
char Descr[40];
int  Number; // Max number;
long Offset[500];
} SLDLIB_HDR;

SLDLIB_HDR sld;
SLIB_HDR   sl;
SLIB_ITEM item;

char dospath[100]={ 0 };

FILE *snames;

void main(int argc,char **argv)
{
void *buf;
int h,h2,h3,i;
long len;

if(argc==1)
{
puts("SL2SLD Transfer Utility Version 2.0 BY Alex Chudnovsky");
puts("Usage: SL2SLD.EXE SPRLIB.SL SPRLIB.SLD [SPRLIB.HDR]");
return;
}

strupr(argv[1]);
strupr(argv[2]);

buf=malloc(32000);

if(buf==0)
{
puts("Error: Out of memory!");
return;
}

if((strcmp(argv[1],argv[2]))==0)
{
puts("Error: Given names are the same!");
return;
}


if((h=_open(argv[1],O_RDWR))==-1)
{
printf("Error: Unable to open sprite library: %s;\n\r",argv[1]);
return;
}

if((h2=_creat(argv[2],FA_ARCH))==-1)
{
printf("Error: Unable to creat sprite data library: %s;\n\r",argv[2]);
close(h);
return;
}

if(_read(h,&sl,sizeof(SLIB_HDR))==-1)
{
FileErr:
puts("File error!");
return;
}

printf("Processing number is %d;\n",sl.Number);
printf("Working ");

strcat(sld.Descr,"*** Sprite Data Library v2.0 ***");
sld.SL[0]='S';
sld.SL[1]='D';
sld.Number=sl.Number;

_write(h2,&sld,sizeof(sld));


if((snames=fopen("sprites.nam","w+"))==0)
{
puts("ERROR creating file SPRITES.NAM!");
getch();
}

for(i=0; i<sl.Number; i++)
{

_read(h,&item,sizeof(SLIB_ITEM));

strupr(item.FileName);

fputs(item.FileName,snames);
fputs("\n",snames);

if(strcmp(item.FileName,"__NONAME.SPR")==0)
{
sld.Offset[i]=0L;
continue;
}

sld.Offset[i]=lseek(h2,0L,SEEK_END);

if((h3=_open(item.FileName,O_RDWR))==-1)
{
printf("Error: Unable to open file from sprite library: %s;\n\r",item.FileName);
return;
}

len=lseek(h3,0L,SEEK_END);

if(len==-1)
{
puts("Lseek error!");
return;
}

printf("(%03d) %14s\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b",i+1,item.FileName);
lseek(h3,0L,SEEK_SET);

_read(h3,buf,len);
_write(h2,buf,len);

close(h3);
}

lseek(h2,0L,SEEK_SET);
_write(h2,&sld,sizeof(sld));

close(h);
close(h2);

puts("\nDone.");

if(argc==4)
{
if(strcmp(argv[1],argv[3])==0)
{
puts("The first and the third argument are the same!");
return;
}
if(strcmp(argv[2],argv[3])==0)
{
puts("The second and the third argument are the same!");
return;
}

strcat(dospath,"copy ");
strcat(dospath,argv[1]);
strcat(dospath," ");
strcat(dospath,argv[3]);
system(dospath);
printf("Header file (%s) made.\n",argv[3]);

}

fclose(snames);
}