#include "master.h"

void LoadVGAPalette(void)
{
char name[20];

name[0]=0;
if((getfile("*.PAL","Load VGA palette",name))==0) {  return; }
LoadPalette(name);
}

void Down256Color(void)
{
int j;

j=(curcolor%16);

VideoSetFillStyle(SOLID_FILL,curcolor);
VideoBar(__maxx-40,45+j*colsize,__maxx-25,45+colsize+j*colsize);

if(curcolor==255)
{

for(j=0;j<16;j++) {
 VideoSetFillStyle(SOLID_FILL, j);
 VideoBar(__maxx-40,45+j*colsize,__maxx-25,45+colsize+j*colsize);
		  }

 curcolor=0;

 VideoSetColor(~curcolor);
 VideoRectangle(__maxx-40,45,__maxx-25, 45+colsize);
 return;

}


if((curcolor%16)==15)
{

for(j=0; j<16; j++) {
 VideoSetFillStyle(SOLID_FILL, curcolor+j+1);
 VideoBar(__maxx-40,45+j*colsize,__maxx-25,45+colsize+j*colsize);
		  }

 curcolor++;
 VideoSetColor(~curcolor);
 VideoRectangle(__maxx-40,45,__maxx-25,45+colsize);
 return;

}

 curcolor++; j++;
 VideoSetColor(~curcolor);
 VideoRectangle(__maxx-40,45+j*colsize,__maxx-25,45+colsize+j*colsize);

}

void Up256Color(void)
{
int j;

j=(curcolor%16);

VideoSetFillStyle(SOLID_FILL,curcolor);
VideoBar(__maxx-40,45+j*colsize,__maxx-25,45+colsize+j*colsize);

if(curcolor==0)
{
 curcolor=240;

for(j=0;j<16;j++) {
 VideoSetFillStyle(SOLID_FILL,curcolor+j);
 VideoBar(__maxx-40,45+j*colsize,__maxx-25,45+colsize+j*colsize);
		  }

 curcolor=255;
 VideoSetColor(~curcolor);
 VideoRectangle(__maxx-40,45+15*colsize,__maxx-25, 45+16*colsize);
 return;
}


if((curcolor%16)==0)
{
int cc=curcolor-16;

for(j=0; j<16; j++) {
 VideoSetFillStyle(SOLID_FILL, cc+j);
 VideoBar(__maxx-40,45+j*colsize,__maxx-25,45+colsize+j*colsize);
		  }

 curcolor--;
 j=(curcolor%16);
 VideoSetColor(~curcolor);
 VideoRectangle(__maxx-40,45+15*colsize,__maxx-25,45+16*colsize);
 return;

}

 curcolor--; j--;
 VideoSetColor(~curcolor);
 VideoRectangle(__maxx-40,45+j*colsize,__maxx-25,45+colsize+j*colsize);

}

void SetPaletteRegister(char r,char g,char b,int reg)
{

asm {

mov ax,1010h
mov bx,reg
mov dh,r
mov ch,g
mov cl,b
int 10h

};

}

typedef struct _PALETTE {
char R,G,B;
} PALETTE;


PALETTE GetPaletteRegister(int reg)
{
PALETTE p;
char r,g,b;

asm  {

mov ax,1015h
mov bx,reg
int 10h
mov r,dh
mov g,ch
mov b,cl

};

p.R=r;
p.G=g;
p.B=b;

return p;
}

void PaletteSetup(void)
{
PALETTE r;

r=GetPaletteRegister(curcolor);

WINDOW s(-1,-1,300,180,"Palette SetUp",DLG_FRAME);
BUTTON c(s.x+40,s.y+150,80,20,"&Cancel",kbEsc);
BUTTON o(s.x+180,s.y+150,80,20,"&OK",kbEnter);

VSCROLL red(s.x+70,s.y+60,85,256/4-1);
red.absposition=r.R;
VSCROLL green(s.x+140,s.y+60,85,256/4-1);
green.absposition=r.G;
VSCROLL blue(s.x+210,s.y+60,85,256/4-1);
blue.absposition=r.B;


s.ShowWindow();
c.Show();
o.Show();

red.Show();
blue.Show();
green.Show();

mouse_hide();
VideoSetColor(0);
VideoRectangle(s.x+40-1,s.y+20-1,s.x+260+1,s.y+40+1);
VideoSetFillStyle(0,curcolor);
VideoBar(s.x+40,s.y+20,s.x+260,s.y+40);
mouse_show();

s.SetTextColor(0);
s.Print(60,38,"Red");
s.Print(120,38,"Green");
s.Print(190,38,"Blue");

EVENT e;
go:
e=_GetEvent();


if(o.ProcessEvent(&e)==PRESSED)
{
goto end;
}

if(c.ProcessEvent(&e)==PRESSED)
{
SetPaletteRegister(r.R,r.G,r.B,curcolor);
goto end;
}


if(blue.ProcessEvent(e)!=0)
{
SetPaletteRegister(red.absposition,green.absposition,blue.absposition,curcolor);
goto go;
}

if(red.ProcessEvent(e)!=0)
{
SetPaletteRegister(red.absposition,green.absposition,blue.absposition,curcolor);
goto go;
}

if(green.ProcessEvent(e)!=0)
{
SetPaletteRegister(red.absposition,green.absposition,blue.absposition,curcolor);
goto go;
}

goto go;

end:

s.DeleteWindow();
}

