#include "stdio.h"
#include "dos.h"
#include "io.h"
#include "conio.h"
#include "alloc.h"
#include "fcntl.h"
#include "stdlib.h"
#include "sprite.h"

char far *VirtualPage;

int  LoadSprite(char *file,SPRITE *s)
{
SPR_HDR head;
int h;

if((h=_open(file,O_RDWR))==-1)
{

printf("\n\rUnable to open '%s'",file);
return -1;

}

if(_read(h,&head,sizeof(head))==-1)
{

printf("\n\rUnable to read '%s' header",file);
close(h);
return -1;

}

if(head.Type!=3)
{
printf("\n\rBad type number: '%d'; (must be 3)",head.Type);
close(h);
return -1;
}



s->x=0;
s->y=0;
s->dx=head.SizeX;

if((head.SizeX%2)!=0)
{
printf("\n\rSprite 'SizeX' must be alligned by 2 bytes;");
close(h);
return -1;
}

s->dy=head.SizeY;

if((s->SaveMem=(char *) malloc((s->dx)*(s->dy)))==0)
{
printf("\n\rOut of memory to load sprite data;");
close(h);
return -1;
}

if((s->Data=(char *) malloc((s->dx)*(s->dy)))==0)
{
printf("\n\rOut of memory to load sprite data;");
free(s->SaveMem);
close(h);
return -1;
}

if(_read(h,s->Data,head.DataLen)==-1)
{
printf("\n\rUnable to read sprite data;");
free(s->SaveMem);
free(s->Data);
close(h);
return -1;
}

close(h);
return 0;
}

void ReleaseSprite(SPRITE *s)
{

free(s->SaveMem);
free(s->Data);
s->SaveMem=0;
s->Data=0;

}


void GetVirtualPage(int x,int y,char DeltaX,char DeltaY,char *mem)
{
int SubDelta=320-DeltaX;

asm {

pusha
push es
push ds
push bp
cld

mov ax,y
mov bx,320
mul bx

mov bx,x
add ax,bx

mov di,ax

les ax,VirtualPage
add di,ax
// ES:DI on first byte:

mov cl,DeltaY
mov bl,DeltaX
mov ch,0
mov bh,0
shr bx,1
mov dx,SubDelta
mov si,di
push es
les di,mem
pop ds

};

Loop_Y:

asm {

mov bp,cx

mov cx,bx

rep movsw
add si,dx

mov cx,bp
loop Loop_Y

pop bp
pop ds
pop es
popa

};

}

void PutVirtualPage(int x,int y,char DeltaX,char DeltaY,char *mem)
{

int SubDelta=320-DeltaX;

asm {

pusha
push es
push ds
push bp
cld

mov ax,y
mov bx,320
mul bx

mov bx,x
add ax,bx

mov di,ax

les ax,VirtualPage
add di,ax
// ES:DI on first byte:

xor cx,cx
xor bx,bx
mov cl,DeltaY
mov bl,DeltaX
shr bx,1
mov dx,SubDelta
mov si,di

lds si,mem

};

Loop_Y:

asm {

mov bp,cx

mov cx,bx
rep movsw
add di,dx

mov cx,bp
loop Loop_Y

pop bp
pop ds
pop es
popa

};


}

void DrawVirtualPage(int x,int y,char DeltaX,char DeltaY,char far *mem)
{

int SubDelta=320-DeltaX;

asm {

//pusha
push es
push ds
push bp
cld

//mov ax,y
//mov bx,320
//mul bx
mov ax,320
mul [y]

mov bx,x
//add ax,bx
add ax,x

//mov di,ax

les di,VirtualPage
add di,ax
// ES:DI on first byte:

mov bh,0
mov ch,bh

mov cl,DeltaY
mov bl,DeltaX
mov dx,SubDelta
mov ah,255 // Transparent color:
lds si,mem

};

Loop_Y:

asm {

mov bp,cx

mov cx,bx

};

LoopX:

asm {

lodsb
cmp al,ah
je Next
stosb
loop LoopX
add di,dx

mov cx,bp
loop Loop_Y

pop bp
pop ds
pop es
//popa

};

return;

Next:

asm {

inc di
loop LoopX

add di,dx

mov cx,bp
loop Loop_Y

pop bp
pop ds
pop es
//popa

};

}



void GetMemory(int x,int y,int DeltaX,int DeltaY,char *mem)
{
int SubDelta=320-DeltaX;

asm {

pusha
push es
push ds
push bp
cld

mov ax,y
mov bx,320
mul bx

mov bx,x
add ax,bx

mov di,ax

mov ax,0a000h
mov es,ax
// ES:DI on first byte:

mov cx,DeltaY
mov bx,DeltaX
shr bx,1
mov dx,SubDelta
mov si,di
push es
les di,mem
pop ds

};

Loop_Y:

asm {

mov bp,cx

mov cx,bx

rep movsw
add si,dx

mov cx,bp
loop Loop_Y

pop bp
pop ds
pop es
popa

};

}

void V_GetMemory(int x,int y,int DeltaX,int DeltaY,char *mem)
{
int SubDelta=320-DeltaX;

asm {

pusha
push es
push ds
push bp
cld

mov ax,y
mov bx,320
mul bx

mov bx,x
add ax,bx

mov di,ax

les ax,VirtualPage
//mov ax,0a000h
//mov es,ax
// ES:DI on first byte:

mov cx,DeltaY
mov bx,DeltaX
shr bx,1
mov dx,SubDelta
add di,ax
mov si,di
push es
les di,mem
pop ds

};

Loop_Y:

asm {

mov bp,cx

mov cx,bx

rep movsw
add si,dx

mov cx,bp
loop Loop_Y

pop bp
pop ds
pop es
popa

};

}



void PutMemory(int x,int y,int DeltaX,int DeltaY,char *mem)
{

int SubDelta=320-DeltaX;

asm {

pusha
push es
push ds
push bp
cld

mov ax,y
mov bx,320
mul bx

mov bx,x
add ax,bx

mov di,ax

mov ax,0a000h
mov es,ax
// ES:DI on first byte:

mov cx,DeltaY
mov bx,DeltaX
shr bx,1
mov dx,SubDelta
mov si,di

lds si,mem

};

Loop_Y:

asm {

mov bp,cx

mov cx,bx
rep movsw
add di,dx

mov cx,bp
loop Loop_Y

pop bp
pop ds
pop es
popa

};


}


void DrawMemory(int x,int y,char DeltaX,char DeltaY,char far *mem)
{

int SubDelta=320-DeltaX;

asm {

pusha
push es
push ds
push bp
cld

mov ax,y
mov bx,320
mul bx

mov bx,x
add ax,bx

mov di,ax

mov ax,0a000h
mov es,ax
// ES:DI on first byte:

xor bx,bx
xor cx,cx

mov cl,DeltaY
mov bl,DeltaX
mov dx,SubDelta
mov ah,255 // Transparent color:
lds si,mem

};

Loop_Y:

asm {

mov bp,cx

mov cx,bx

};

LoopX:

asm {

lodsb
cmp al,ah
je Next
stosb
loop LoopX
add di,dx

mov cx,bp
loop Loop_Y

pop bp
pop ds
pop es
popa

};

return;

Next:

asm {

inc di
loop LoopX

add di,dx

mov cx,bp
loop Loop_Y

pop bp
pop ds
pop es
popa

};

}

void InitSprite(SPRITE *s)
{
GetMemory(s->x,s->y,s->dx,s->dy,s->SaveMem);
//DrawMemory(s->x,s->y,s->dx,s->dy,s->Data);
PutMemory(s->x,s->y,s->dx,s->dy,s->Data);
}


void DrawSprite(SPRITE *);

// Waiting for vertical light returning:
void WaitVert(void)
{

asm {
xor ax,ax
mov es,ax
mov dx,es:[463h]
add dl,6
in al,dx

test al,1
jnz Wait_On

};

Wait_Off:

asm {

in al,dx
test al,1
jz Wait_Off

};

Wait_On:

asm {

in al,dx
test al,8
jnz Wait_On

};

}


int  InitSpriteManager(void)
{

if((VirtualPage=(char *) malloc(64*1024-24))==0)
{
puts("\n\rSpriteManager: Not enough memory for VirtualPage;");
return -1;
}

return 0;
}

void  CloseSpriteManager(void)
{
free(VirtualPage);
}


void Screen2VirtualPage(int x,int y,char DeltaX,char DeltaY)
{

int SubDelta=320-DeltaX;

asm {

pusha
push es
push ds
push bp
cld

mov ax,y
mov bx,320
mul bx

mov bx,x
add ax,bx

mov di,ax

mov ax,0a000h
mov es,ax
// ES:DI on first byte:

mov cl,DeltaY
mov bl,DeltaX
mov ch,0
mov bh,0
//shr bx,1
mov dx,SubDelta
mov si,di

les di,VirtualPage
add di,si

mov ax,0a000h
mov ds,ax

};

Loop_Y:

asm {

mov bp,cx

mov cx,bx

rep movsb
add si,dx
add di,dx

mov cx,bp
loop Loop_Y

pop bp
pop ds
pop es
popa

};


}


void VirtualPage2Screen(int x,int y,char DeltaX,char DeltaY)
{

int SubDelta=320-DeltaX;

asm {

pusha
push es
push ds
push bp
cld

mov ax,y
mov bx,320
mul bx

mov bx,x
add ax,bx

mov di,ax

mov ax,0a000h
mov es,ax
// ES:DI on first byte:

mov cl,DeltaY
mov bl,DeltaX
mov ch,0
mov bh,0

//  Warning:
shr bx,1

mov dx,SubDelta
mov si,di

lds si,VirtualPage
add si,di

};

Loop_Y:

asm {

mov bp,cx

mov cx,bx
//rep movsb

rep movsw

add di,dx
add si,dx

mov cx,bp
loop Loop_Y

pop bp
pop ds
pop es
popa

};

}


int  LoadTileWithHandle(int h,TILE *s)
{
SPR_HDR head;
long off=lseek(h,0,SEEK_CUR);

if(_read(h,&head,sizeof(head))==-1)
{
printf("\n\rLoadTileWithHandle: Unable to read header at %p!",off);
close(h);
return -1;
}

if(head.Type!=3)
{
printf("\n\rLoadTileWithHandle: Bad type number: '%d' at %p; (must be 3)",head.Type,off);
close(h);
return -1;
}

s->dx=head.SizeX;

if((head.SizeX%2)!=0)
{
printf("\n\rLoadTileWithHandle: Sprite 'SizeX' must be alligned by 2 bytes now is %d at %p;",head.SizeX,off);
close(h);
return -1;
}

s->dy=head.SizeY;

if((s->Data=(char *) malloc((s->dx)*(s->dy)))==0)
{
printf("\n\rLoadTileWithHandle: Out of memory to load sprite data! Needed: %d bytes at %p;",(s->dx)*(s->dy),off);
close(h);
return -1;
}

if(_read(h,s->Data,head.SizeX*head.SizeY)==-1)
{
printf("\n\rLoadTileWithHandle: Unable to read sprite data at %p!",off);
free(s->Data);
close(h);
return -1;
}

return 0;
}


int  LoadTile(char *file,TILE *s)
{
SPR_HDR head;
int h;

if((h=_open(file,O_RDWR))==-1)
{
printf("\n\rLoadTile: Unable to open tile on '%s'",file);
return -1;
}

if(_read(h,&head,sizeof(head))==-1)
{
printf("\n\rLoadTile: Unable to read header on '%s'",file);
close(h);
return -1;
}

if(head.Type!=3)
{
printf("\n\rLoadTile: Bad type number: '%d' on '%s'; (must be 3)",head.Type,file);
close(h);
return -1;
}

s->dx=head.SizeX;

if((head.SizeX%2)!=0)
{
printf("\n\rLoadTile: Sprite 'SizeX' must be alligned by 2 bytes now is %d on tile '%s';",head.SizeX,file);
close(h);
return -1;
}

s->dy=head.SizeY;

if((s->Data=(char *) malloc((s->dx)*(s->dy)))==0)
{
printf("\n\rLoadTile: Out of memory to load sprite data on '%s' needed: %d bytes;",file,(s->dx)*(s->dy));
close(h);
return -1;
}

if(_read(h,s->Data,head.SizeX*head.SizeY)==-1)
{
printf("\n\rLoadTile: Unable to read sprite data on '%s';",file);
free(s->Data);
close(h);
return -1;
}

close(h);
return 0;
}


void ReleaseTile(TILE *s)
{
if(s->Data==0) return;

free(s->Data);
s->Data=0;
}

void ShowVirtualTileAt(int x,int y,TILE *tile)
{
PutVirtualPage(x,y,tile->dx,tile->dy,tile->Data);
}

void DrawVirtualTileAt(int x,int y,TILE *tile)
{
DrawVirtualPage(x,y,tile->dx,tile->dy,tile->Data);
}

void PutVirtualTileAt(int x,int y,TILE *tile)
{
PutVirtualPage(x,y,tile->dx,tile->dy,tile->Data);
}


void VirtualClear(int x1,int y1,int x2,int y2)
{
int DeltaX=x2-x1;

int DeltaY=y2-y1+1;
int SubDelta=320-DeltaX;

asm {

pusha
push es
cld

mov ax,y1
mov bx,320
mul bx

mov bx,x1
add ax,bx

mov di,ax

les ax,VirtualPage
add di,ax
// ES:DI on first byte:

mov cx,DeltaY
mov bx,DeltaX
mov dx,SubDelta
xor ax,ax
shr bx,1
};

Loop_Y:

asm {

push cx

mov cx,bx
rep stosw
add di,dx

pop cx
loop Loop_Y

pop es
popa

};

}

void ShowTileAt(int x,int y,TILE *tile)
{
PutMemory(x,y,tile->dx,tile->dy,tile->Data);
}

void DrawTileAt(int x,int y,TILE *tile)
{
DrawMemory(x,y,tile->dx,tile->dy,tile->Data);
}

