/*


	 Sprite Header File Version 2.0 BY Alex Chudnovsky
	 Copyright (C) Mythical Software Group


*/


// Sprite file header:

typedef struct _SPR_HDR_ {

char NK[2];      // Signature of Sprite Editor: 'NK';
char Version;
char VideoMode;
char Type;
int  SizeX;
int  SizeY;
int  DataLen;    // Lengh of base Data: mustn't be equal to zero;
int  MaskLen;    // Length of Mask: If zero -> no mask in sprite;

} SPR_HDR;


typedef struct _SPRITE_ {

int   x,y;
char  dx,dy;
char far *Data;
char far *SaveMem;         // If any;

}  SPRITE;

typedef struct _TILE_ {

char  dx,dy;
char far *Data;

}  TILE;


typedef struct _OBJECT_ {

int  x,y;
char far *SaveMem;
TILE *Tile;

}  OBJECT;

#define MAX_OBJECTS 1

// Sprite manitulation routines:

int  InitSpriteManager(void);
void InitRefreshManager(void);

int  LoadSprite(char *,SPRITE *);
int  LoadTile(char *,TILE *);
int  LoadTileWithHandle(int,TILE *);
void ReleaseTile(TILE *);

int  InitObjectWithTile(OBJECT *,TILE *);

int  PlaceObject(int,OBJECT *);
int  InsertObject(int,OBJECT *);
int  PlaceTile(int,TILE *);
int  InsertTile(int,TILE *);
int  MoveObjectTo(int,int,int);
int  DeleteObject(int);

void ShowAllObjects(void);
void RefreshScreen(void);

void MakeSpriteFromTile(SPRITE *,TILE *);
void ReleaseSprite(SPRITE *);
void DrawSprite(SPRITE *);
void DrawSpriteAt(int,int,SPRITE *);
void InitSprite(SPRITE *);
void VirtualPage2Screen(int,int,char,char);
void Screen2VirtualPage(int,int,char,char);

void GetVirtualPage(int,int,char,char,char *);
void PutVirtualPage(int,int,char,char,char *);
void DrawVirtualPage(int,int,char,char,char *);


void PutMemory(int x,int y,int DeltaX,int DeltaY,char *mem);
void GetMemory(int x,int y,int DeltaX,int DeltaY,char *mem);
void DrawMemory(int x,int y,int DeltaX,int DeltaY,char *mem);

void OpenRefreshManager(char);
void CloseRefreshManager(void);
void ShowTileAt(int x,int y,TILE *tile);
void ShowVirtualTileAt(int x,int y,TILE *tile);
void DrawVirtualTileAt(int x,int y,TILE *tile);