/*

 Video Routines Version 1.0 BY Alex Chudnovsky
 Copyright (C) Mythical Software Group 1993/94

*/

#include "stdlib.h"
#include "stdio.h"
#include "conio.h"
#include "time.h"
#include "string.h"
#include "fcntl.h"
#include "dos.h"
#include "stdarg.h"
#include "ctype.h"
#include "process.h"
#include "dir.h"
#include "io.h"
#include "alloc.h"

#include "video.h"

//#include "bwg.h"
#include "fonts.h"

char FillPattern;
char FillColor;
int CoordMaxX;
int _VGA=0;
void SETREG(int,char,char);
void mouse_hide(void);
void mouse_show(void);

/*
#define BYTEOF(x,y) ((y)*BytesPerLine+((x)/8))
#define BITOF(x)  (0x80>>((x)&0x07))        // 000x0000

#define GDC              0x3CE
#define GDCReset         0x00
#define GDCEnable        0x01
#define GDCColorCompare  0x02
#define GDCDataRotate    0x03
#define GDCReadMapSel    0x04
#define GDCMode          0x05
#define GDCMisc          0x06
#define GDCColorDC       0x07
#define GDCBitMask       0x08
*/
void SETREG(int,char,char);
void SetWordReg(int,int);

/*
#define SETMASK(m) SETREG(GDC,GDCBitMask,(m))

#define SetWordReg(c,w) asm mov dx,c;\
			asm mov ax,w;\
			asm out dx,ax;

#define SetWriteMode(m) asm {\
			      mov dx,3ceh;\
			      mov ah,5;\
			      mov al,m;\
			      out dx,ax;\
			    };

#define SetWriteMode0()  SetWordReg(0x3ce,0x0005);
#define SetWriteMode1()  SetWordReg(0x3ce,0x0105);
#define SetWriteMode2()  SetWordReg(0x3ce,0x0205);

#define EnablePlanes(p)   SETREG(0x3c4,2,p)
#define EnableAllPlanes() SetWordReg(0x3c4,0x0F02)
#define ZeroDataRotate()  SetWordReg(GDC,0x0003)

#define SetReadPlane(m)    SETREG(GDC,GDCReadMapSel,(m));

#define SetWritePlane0()   SetWordReg(0x3c4,0x0102);
#define SetWritePlane1()   SetWordReg(0x3c4,0x0202);
#define SetWritePlane2()   SetWordReg(0x3c4,0x0402);
#define SetWritePlane3()   SetWordReg(0x3c4,0x0802);

#define SetReadPlane0()   SetWordReg(GDC,0x0004);
#define SetReadPlane1()   SetWordReg(GDC,0x0104);
#define SetReadPlane2()   SetWordReg(GDC,0x0204);
#define SetReadPlane3()   SetWordReg(GDC,0x0304);

#define SetWritePlane(m)  SETREG(0x3c4,2,1<<(m));
#define SetAllBits()      SetWordReg(GDC,0xFF08);
*/

void SetQuickAccess(void);
void QuickVideoOutTextXY(int x,int y,char *s);

char EGAActivePage;

int  CurrentColor;
long TotalCacheRAM=0;
long FreeCacheRAM=0;
long CacheOffset=0;
int  RealCacheOffset;
long CacheLength=0;
int  CacheError;
int  GlobalOffset;
char BytesPerLine;
int  PageSize;
char ActivePage=0;
unsigned char far *Font8;
int  CoordMaxY;

int PageOff[8];

int  GetVideoMode(void);
void VideoOutCharXY(int,int,char);
void VideoOutByteXY(int,int,char,char);

void VGAOutTextXY(int x,int y,char *s);
void VGAOutCharXY(int x,int y,char c);
void VGAOutByteXY(int x,int y,char b,char color);


long GetPageSize(void)
{

switch(GetVideoMode())
{

case 0x0d:
	   BytesPerLine=40;
	   CoordMaxY=319;
	   CoordMaxX=319;
	   return (320L*200L/2L);

case 0x13: BytesPerLine=200;
	   CoordMaxY=199;
	   CoordMaxX=319;
	   _VGA=11;
	   return (320L*200L);

case 0x0e: BytesPerLine=80;
	   CoordMaxY=199;
	   CoordMaxX=639;
	   return (640L*200L/2L);

case 0x10: BytesPerLine=80;
	   CoordMaxY=349;
	   CoordMaxX=639;
	   return (640L*350L/2L);

case 0x12: BytesPerLine=80;
	   CoordMaxY=479;
	   CoordMaxX=639;
	   return (640L*480L/2L);

default: puts("VIDEO->GetVideoPage: Not supported screen mode installed!");
	 exit(11);

};


}


int GetVideoRAM(void)
{
_AH=0x12;
_BL=0x10;
asm int 10h;

return ((_BL+1)*64);
}


int  CacheImageSize(int x1,int y1,int x2,int y2)
{
int size;

size=((x2/8+1)-(x1/8-1))*(y2-y1)*4;
return size;
}

void InitVideoMode(char mode)
{
_AH=0;
_AL=mode;
asm int 10h;
}


int GetVideoMode(void)
{
_AH=0x0f;
asm int 10h;

return _AL;
}

void SetActivePage(int page)
{
EGAActivePage=page;
}

void VideoSetVisualPage(int page)
{
//if(_VGA==0) setvpage(page);
}

void VideoSetActivePage(int page)
{
ActivePage=page;

//if(_VGA==0) setrwpage(page,page);

}

void VideoSetFillStyle(int pattern,int col)
{
FillPattern=pattern;
FillColor=col;

/*
if(_VGA==0)
{
color(col);
fillbgcolor(col);
}
*/
}

void VideoBar(int x1,int y1,int x2,int y2)
{
if(_VGA==0) ;
//recfill(x1,y1,x2,y2);
else VGABar(x1,y1,x2,y2);
}

void VideoSetColor(int col)
{
CurrentColor=col;

//if(_VGA==0) color(col);
}

int  VideoGetColor(void)
{
return CurrentColor;
}


void VideoRectangle(int x1,int y1,int x2,int y2)
{

if(_VGA==0) ; //rectab(x1,y1,x2,y2);
else
{
VGALine(x1,y1,x2,y1);
VGALine(x2,y1,x2,y2);
VGALine(x1,y2,x2,y2);
VGALine(x1,y1,x1,y2);
}

}

void VideoLine(int x1,int y1,int x2,int y2)
{
if(_VGA==0) ; //lineXY(x1,y1,x2,y2);
else VGALine(x1,y1,x2,y2);
}

void VideoOutCharXY(int x,int y,char c)
{
/*
for(int i=0; i<8; i++)
 VideoOutByteXY(x,y+i,Font8[c*8+i],(char) CurrentColor);
*/
//if(_VGA==0) { EnableAllPlanes(); }
}


void VideoOutTextXY(int x,int y,char *s)
{

if(Font8==0)
{
puts("VIDEO->VideoOutTextXY: Font 8x8 not initialized!");
getch();
return;
}

if(_VGA==0)
{
/*
int c=0;
SetWriteMode0();
ZeroDataRotate();

while(s[c]!=0)
{ VideoOutCharXY(x+c*8,y,s[c]); c++; }
*/
}
else { VGAOutTextXY(x,y,s); }

}


void QuickVideoOutTextXY(int x,int y,char *s)
{
VideoOutTextXY(x,y,s);
}

int  VideoGetMaxX(void) { return CoordMaxX; }

int  VideoGetMaxY(void) { return CoordMaxY; }

int  VideoTextWidth(char *s) { return (strlen(s)*8); }

int  VideoTextHeight(char *s) { return 8; }

void InitVideo(void)
{
int s,o;

if(Font8==0)
{
// Get built-in ROM 8x8 font

asm {

push ax
push bx
push cx
push dx

push es
push bp

mov ax,1130h
mov bh,3          // Get 8x8 ROM font...
int 10h

mov ax,bp
mov bx,es

pop bp
pop es

mov word ptr s,bx
mov word ptr o,ax

pop dx
pop cx
pop bx
pop ax

};

Font8=(unsigned char far *) MK_FP(s,o);

}

}



void OutByteXY(int x,int y,char b,char color,char back)
{
if(_VGA==0) {
/*
VideoOutByteXY(x,y,b,color);
VideoOutByteXY(x,y,~b,back);
*/
	    }
else {
VGAOutByteXY(x,y,b,color);
VGAOutByteXY(x,y,~b,back);
}

}


void OutCharXY(int x,int y,char c,char col,char b)
{

for(int i=0; i<8; i++)
 OutByteXY(x,y+i,Font8[c*8+i],col,b);

}

void Text8(int x,int y,int col,int b,char *s)
{
int c=0;

x=x-x%8;

while(s[c]!=0)
{ OutCharXY(x+8*c,y,s[c],col,b); c++; }

}

int  LoadFont8x8(char *FileName)
{
void far *FontMem=malloc(256*8);
int handle;

if ((handle = _open(FileName, O_RDONLY)) == -1)
{
   printf("Error: Unable to open user system font: '%s';\n\r",FileName);
   getch();
   return 1;
}


if((_read(handle,FontMem,256*8))==-1)
{
   printf("Error: Unable to read user system font data: '%s';\n\r",FileName);
   getch();
   return 1;
}

Font8=(unsigned char far*) FontMem;

return 0;
}

// Video Block Routines:

unsigned EvaluateBlockSize(int x1,int y1,int x2,int y2)
{
int xt1,xt2;

if(_VGA==0)
{
//xt1=x1-x1%8-1;
//xt2=x2-x2%8+1;
}
else
{
xt1=x1-2;
xt2=x2+2;
}

return ((y2-y1)*(xt2-xt1));
}

void GetBlock(int x,int y,int dx,int dy,char *buff)
{
char *buf=buff;

int DeltaX=dx*8;
int DeltaY=dy;
int SubDelta=320-DeltaX;

asm {

pusha
push es
push ds
cld

mov ax,y
mov bx,320
mul bx

mov bx,x
add ax,bx

mov di,ax

mov ax,0a000h
mov es,ax
// ES:DI on first byte:

mov cx,DeltaY
mov bx,DeltaX
shr bx,1
mov dx,SubDelta
mov si,di
push es
les di,buff
pop ds


};

Loop_Y:

asm {

push cx

mov cx,bx

rep movsw
add si,dx

pop cx
loop Loop_Y

pop ds
pop es
popa

};

} // End function.


void PutBlock(int x,int y,int dx,int dy,char *buff)
{
char *buf=buff;

int DeltaX=dx*8;
int DeltaY=dy;
int SubDelta=320-DeltaX;

asm {

pusha
push es
push ds
cld

mov ax,y
mov bx,320
mul bx

mov bx,x
add ax,bx

mov di,ax

mov ax,0a000h
mov es,ax
// ES:DI on first byte:

mov cx,DeltaY
mov bx,DeltaX
shr bx,1
mov dx,SubDelta
mov si,di

lds si,buff

};

Loop_Y:

asm {

push cx

mov cx,bx
rep movsw
add di,dx

pop cx
loop Loop_Y

pop ds
pop es
popa

};


} // End function.

void VideoPutPixel(int x,int y,char color)
{

if(_VGA==0) ; //wrpixel(x,y,color);
else VGAPutPixel(x,y,color);

}

char VideoGetPixel(int x,int y)
{

if(_VGA==0) return 0; //(rdpixel(x,y));
else return (VGAGetPixel(x,y));

}

void VGAPutPixel(int x,int y,char color)
{

asm {
push ax
push bx
push es

mov ax,y
mov bx,320
mul bx

mov bx,x
add ax,bx

xchg bx,ax

mov ax,0a000h
mov es,ax

mov al,color
mov es:[bx],al

pop es
pop bx
pop ax
};

}

char VGAGetPixel(int x,int y)
{
char *RealMem=(char *) MK_FP(0xA000,x+y*320);

return (*RealMem);
}

void VideoEraseScr(int col)
{
if(_VGA==0) ; //erasescr(col);

else {

if(ActivePage==0)
{

int tmp=FillColor;
FillColor=col;
VGABar(0,0,319,199);
FillColor=tmp;
}

}

}


void VGABar(int x1,int y1,int x2,int y2)
{
int DeltaX=x2-x1+1;
int DeltaY=y2-y1+1;
int SubDelta=320-DeltaX;

asm {

pusha
push es
cld

mov ax,y1
mov bx,320
mul bx

mov bx,x1
add ax,bx

mov di,ax

mov ax,0a000h
mov es,ax
// ES:DI on first byte:

mov cx,DeltaY
mov bx,DeltaX
mov dx,SubDelta
mov al,FillColor
mov ah,al

};

Loop_Y:

asm {

push cx

mov cx,bx
rep stosb
add di,dx

pop cx
loop Loop_Y

pop es
popa

};

}

void VGALine(int x1,int y1,int x2,int y2)
{
int v;

// Vertical line:

if(x1==x2)
{

for(v=y1; v<=y2; v++)
 VGAPutPixel(x1,v,CurrentColor);

return;
}

// Horizontal line:

if(y1==y2)
{

for(v=x1; v<=x2; v++)
 VGAPutPixel(v,y1,CurrentColor);

return;
}

}


void VGAOutByteXY(int x,int y,char b,char color)
{
// VGA Output:
if(b==0) return;

char i=0;
char s=0x80;

for(i=0; i<8; i++)
{

if((b & s)!=0) VGAPutPixel(x+i,y,color);

s>>=1;

}

}

void VGAOutCharXY(int x,int y,char c)
{

for(int i=0; i<8; i++)
 VGAOutByteXY(x,y+i,Font8[c*8+i],(char) CurrentColor);

}

void VGAOutTextXY(int x,int y,char *s)
{

int c=0;

while(s[c]!=0)
{ VGAOutCharXY(x+c*8,y,s[c]); c++; }

}

