/*


  Video EGA/VGA Routines Version 1.0
  Copyright (C) Mythical Software Group

     VideoCache Feature:

*/

#define CACHE_NO_ERR      0
#define CACHE_NO_MEM      1
#define CACHE_NO_HANDLES  2

typedef struct _CACHE {

char flags;
int offset;
int size;
char next;


} CACHE;


long GetPageSize(void);
int  GetVideoRAM(void);     // ...Kbytes;
void SetCacheRAM(long,long);
long GetCacheSize(void);
long GetFreeCache(void);
int  GetCacheError(void);
void InitCache(void);
char AllocateCache(unsigned);
void FreeCache(char);
int  CacheImageSize(int,int,int,int);
void InitVideoMode(char);
char GetPixelVGA13h(int x, int y);
void PutPixelVGA13h(int x, int y, char color);
void ClearPageVGA13h(char page,char color);
void ScrollUpVGA13h(int,int,int,int,char);
void MoveLineVGA13h(int,int,int);
void MoveImageVGA13h(int,int,int,int,int,int);
void GetImageVGA13h(int,int,int,int,char *);
void PutImageVGA13h(int,int,int,int,char *);
void EGASetActivePage(int);
void EGAPutPixel(int,int,char);
void VideoSetActivePage(int page);
void VideoSetVisualPage(int page);

void VideoSetFillStyle(int,int);
void VideoBar(int,int,int,int);
void VideoSetColor(int col);
int  VideoGetColor(void);

void VideoRectangle(int,int,int,int);
void VideoLine(int,int,int,int);
void VideoOutTextXY(int,int,char *);

int  VideoGetMaxX(void);
int  VideoGetMaxY(void);
int  VideoTextWidth(char *s);
int  VideoTextHeight(char *s);
void InitVideo(void);
void Text8(int,int,int,int,char *);
int  GetVideoMode(void);
int  LoadFont8x8(char *);

// For EGA/VGA/SVGA compatible adapters only:
void  Screen2Cache(int x,int y,int dx,int dy,int page,int handle);
void  Cache2Screen(int x,int y,int dx,int dy,int page,int handle);


unsigned EvaluateBlockSize(int,int,int,int);
void GetBlock(int,int,int,int,char *);
void PutBlock(int,int,int,int,char *);

// For VGA 256 color:
char VGAGetPixel(int,int);
void VGAPutPixel(int,int,char);
void VGARectangle(int,int,int,int);
void VGABar(int,int,int,int);
void VGALine(int,int,int,int);

// Common Routines:
void VideoEraseScr(int);
void VideoPutPixel(int,int,char);
char VideoGetPixel(int,int);

void VideoGetImageSize(int,int);
void VideoGetImage(int,int,int,int,char *);
void VideoPutImage(int,int,int,int,char *);

